## V3.16.0
### Features
* Support HAP Spec R16.
* Support ZBit flash.
* Improve the efficiency of ota when using ZBit flash.
* Add low voltage detection function: if low voltage is detected, the chip will enter sleep state.
* Add accessories stop advertising within 10 minutes in unpaired state for TCF054.
* Add customization functions for PIPA.
* Add firmware type & version check function before OTA upgrade.

### Bug Fixes
* Fix bug: controller-2's identify behavior error for TCH095.
* Fix bug: accessory's behavior error when HAP procedure request during Timed-write procedure for TCB060.
* Fix bug: the char NAME reliability read fail for TCS003 with tools HCA3.03.
* Fix bug: device can't be removed with Maximum HAP packet size 10 for TCB030.
* Fix bug: pair fail when enable watchdog.
* add omitted unversioned file for v3.15.1.

### BREAKING CHANGES
* N/A

### Features
* 支持HAP R16规范。
* 支持ZBit flash。
* 当使用ZBit Flash时提升OTA效率。
* 增加低电压检测功能：如果检测到低电压，芯片进入休眠状态。
* 增加未配对状态下广播10分钟超时停止功能(对应标准测试用例TCF054)。
* 增加PIPA客户定制功能。
* 增加在OTA升级前进行固件类型和版本检测功能。

### Bug Fixes
* Fix bug: 修复设备在控制器2执行identify时行为出错(对应标准测试用例TCH095)。
* Fix bug: 修复设备在Timed-write流程中执行HAP请求时行为出错(对应标准测试用例TCB060)。
* Fix bug: 修复设备名字特征值在HCA3.03工具的压力测试中读错误(对应标准测试用例TCS003)。
* Fix bug: 修复设备在MaxmuM HAP packet size为10时删除失败(对应标准测试用例TCH030)。
* Fix bug: 修复设备使能watchdog后配对失败。
* Fix bug: 添加v3.15.1 sdk中遗漏的未版本化的文件.

### BREAKING CHANGES
* N/A

## V3.15.1
### Bug Fixes
* fix bug: device can't be added/removed 100 times for TCS011.
* fix bug: small probability of pairing failure(1/50).

### Features
* add API of get/set softAuth's UUID & token.
* add customization functions for PIPA.
* add FwRevisionString UUID in attributes table.

### BREAKING CHANGES
* N/A

### Bug Fixes
* fix bug: 修复设备不能进行100次添加、删除的问题(对应标准测试用例TCS011).
* fix bug: 修复小概率配对失败的问题(1/50).

### Features
* 增加API接口，用户可以获取/设置软认证模式下的UUID和token.
* 增加PIPA客户定制功能.
* 在BLE服务列表里面增加FwRevisionString这个UUID.

### BREAKING CHANGES
* N/A

## V3.15.0
### Features
* support Product Data function for spec R15.
* modify naming for all services refer to HAP spec R15.
* support homekit firmware OTA to mesh firmware.
* generate 4 srp keys when power on, and update the key which is used.
* add simulate functions for test case R9.0.
* add login function for OTA(disabled by defaut).
* add redefine api function for customer.

### Performance Improvements
* clear compile warning.

### BREAKING CHANGES
* N/A

### V3.14.0
### New feature
* add function for TCH084 test(switch srp key in next time of pair setup)
* close timeout for update of IOS application that master disconnect after remove pair.
* rename FanV2 to Fan and use FanV2 replace of Fan service for HAP R14.
* add simulate operation for test case.
* Add emulator function.
* set MTU_SIZE=0x68.
* remove emulator unsupported service uuid and add supported char desc.

### Bugfix
* modify the bug for emulator reboot fail after flash operate.
* solve the compatibility problem that Home app add device unsuccessfully on ios13.
