/********************************************************************************************************
 * @file     app_def_ctrl.h
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2016, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/
#ifndef _APP_DEF_CTRL_H_
#define _APP_DEF_CTRL_H_

#include "./user_app/user_app_define.h"

#ifndef HOMEKIT_MODE_TYPE
#define HOMEKIT_MODE_TYPE					HOMEKIT_DEFAULT_MODE
#endif

#if (HOMEKIT_MODE_TYPE == HOMEKIT_PIPA_MODE)
#define FLASH_ADR_TYPE						FLASH_ADR_TYPE_DUAL_MODE
#define USER_REDEFINE_FUNC_ENABLE			1
#define ENCODE_OTA_BIN_EN					1
#define OTA_FW_TYPE_VER_CHECK_EN			1
#elif (HOMEKIT_MODE_TYPE == HOMEKIT_DEFAULT_MODE)
#define FLASH_ADR_TYPE						FLASH_ADR_TYPE_DEFAULT
#define USER_REDEFINE_FUNC_ENABLE			0
#define ENCODE_OTA_BIN_EN					0
#define OTA_FW_TYPE_VER_CHECK_EN			0
#endif

#endif /* _APP_DEF_CTRL_H_ */

/* %% End Of File %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
