/********************************************************************************************************
 * @file     hk_FanService.c
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2016, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/
#define _HK_FAN_SERVICE_C_
 
 
/* ------------------------------------
    Header Files
   ------------------------------------ */
#include "tl_common.h"
#include "stack/ble/ble.h"
#include "hk_FanService.h"
#include "ble_UUID.h"
#include "hk_TopUUID.h"

extern u32 session_timeout_tick;
extern u8 EventNotifyCNT;
extern store_char_change_value_t* char_save_restore;

extern void assign_current_flash_char_value_addr(void);
extern void store_char_value_to_flash(void);

/* ------------------------------------
    Macro Definitions
   ------------------------------------ */


/* ------------------------------------
    Type Definitions
   ------------------------------------ */


/* ------------------------------------
    Variables Definitions
   ------------------------------------ */
unsigned char hFanActive = 0;
unsigned char hFanCurrentFanState = 0;
unsigned char hFanTargetFanState = 0;
int hFanRotationDirection = 0;
int hFanRotationSpeed = 0;
unsigned char hFanSwingMode = 0;
unsigned char hFanLockPhysicalControls = 0;

unsigned char VAR_FAN_UNKOWN=0;

unsigned short ccc_hFanActive = 0;
unsigned short ccc_hFanCurrentFanState = 0;
unsigned short ccc_hFanTargetFanState = 0;
unsigned short ccc_hFanRotationDirection = 0;
unsigned short ccc_hFanRotationSpeed = 0;
unsigned short ccc_hFanSwingMode = 0;
unsigned short ccc_hFanLockPhysicalControls = 0;

#if FAN_ACTIVE_BRC_ENABLE
    unsigned char bc_para_hFanActive = 1;
#endif

#if FAN_CURRENT_FAN_STATE_BRC_ENABLE
    unsigned char bc_para_hFanCurrentFanState = 1;
#endif

#if FAN_TARGET_FAN_STATE_BRC_ENABLE
    unsigned char bc_para_hFanTargetFanState = 1;
#endif

#if FAN_ROTATION_DIRECTION_BRC_ENABLE
    unsigned char bc_para_hFanRotationDirection = 1;
#endif

#if FAN_ROTATION_SPEED_BRC_ENABLE
    unsigned char bc_para_hFanRotationSpeed = 1;
#endif

#if FAN_SWING_MODE_BRC_ENABLE
    unsigned char bc_para_hFanSwingMode = 1;
#endif

#if FAN_LOCK_PHYSICAL_CONTROLS_BRC_ENABLE
    unsigned char bc_para_hFanLockPhysicalControls = 1;
#endif


const u8 hFanServiceName[10] = "FanService";

const u8 FAN_ACTIVE_VALID_RANGE[2] = {0x00, 0x01};
const u8 FAN_CURRENTFANSTATE_VALID_RANGE[2] = {0x00, 0x02};
const u8 FAN_TARGETFANSTATE_VALID_RANGE[2] = {0x00, 0x01};
const u8 FAN_ROTATION_DIRECTION_VALID_RANGE[8] = { 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00};
const u8 FAN_ROTATION_SPEED_VALID_RANGE[8] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC8, 0x42};
const u8 FAN_SWING_MODE_VALID_RANGE[2] = {0x00, 0x01};
const u8 FAN_LOCK_PHYSICAL_CONTROLS_VALID_RANGE[2] = {0x00, 0x01};

const u8 FAN_ACTIVE_VALID_STEP = 0x01;
const u8 FAN_CURRENTFANSTATE_VALID_STEP = 0x01;
const u8 FAN_TARGETFANSTATE_VALID_STEP = 0x01;
const u8 FAN_ROTATION_DIRECTION_VALID_STEP[4] = { 0x01, 0x00, 0x00, 0x00};
const u8 FAN_ROTATION_SPEED_VALID_STEP[4] = { 0x00, 0x00, 0x80, 0x3F};
const u8 FAN_SWING_MODE_VALID_STEP = 0x01;
const u8 FAN_LOCK_PHYSICAL_CONTROLS_VALID_STEP = 0x01;

const hap_characteristic_desc_t hap_desc_char_Fan_Active_R_S = {hap_PReadWrite_NOTIFY, 0, CFG_UINT8, 0, 2, 1, 0, 0, FAN_ACTIVE_VALID_RANGE, &FAN_ACTIVE_VALID_STEP, BC_PARA_FAN_ACTIVE};
const hap_characteristic_desc_t hap_desc_char_Fan_CurrentFanState_R_S = {hap_PRead_NOTIFY, 0, CFG_UINT8, 0, 2, 1, 0, 0, FAN_CURRENTFANSTATE_VALID_RANGE, &FAN_CURRENTFANSTATE_VALID_STEP, BC_PARA_FAN_CURRENT_FAN_STATE};
const hap_characteristic_desc_t hap_desc_char_Fan_TargetFanState_R_S = {hap_PReadWrite_NOTIFY, 0, CFG_UINT8, 0, 2, 1, 0, 0, FAN_TARGETFANSTATE_VALID_RANGE, &FAN_TARGETFANSTATE_VALID_STEP, BC_PARA_FAN_TARGET_FAN_STATE};
const hap_characteristic_desc_t hap_desc_char_Fan_RotationDirection_R_S = {hap_PReadWrite_NOTIFY, 0, CFG_INT32, 0, 8, 4, 0, 0, FAN_ROTATION_DIRECTION_VALID_RANGE, FAN_ROTATION_DIRECTION_VALID_STEP, BC_PARA_FAN_ROTATION_DIRECTION};
const hap_characteristic_desc_t hap_desc_char_Fan_RotationSpeed_R_S = {hap_PReadWrite_NOTIFY, 0, CFG_FLOAT32_PERCENTAGE, 0, 8, 4, 0, 0, FAN_ROTATION_SPEED_VALID_RANGE, FAN_ROTATION_SPEED_VALID_STEP, BC_PARA_FAN_ROTATION_SPEED};
const hap_characteristic_desc_t hap_desc_char_Fan_SwingMode_R_S = {hap_PReadWrite_NOTIFY, 0, CFG_UINT8, 0, 2, 1, 0, 0, FAN_SWING_MODE_VALID_RANGE, &FAN_SWING_MODE_VALID_STEP, BC_PARA_FAN_SWING_MODE};
const hap_characteristic_desc_t hap_desc_char_Fan_LockPhysicalControls_R_S = {hap_PReadWrite_NOTIFY, 0, CFG_UINT8, 0, 2, 1, 0, 0, FAN_LOCK_PHYSICAL_CONTROLS_VALID_RANGE, &FAN_LOCK_PHYSICAL_CONTROLS_VALID_STEP, BC_PARA_FAN_LOCK_PHYSICAL_CONTROLS};

const hap_characteristic_desc_t hap_desc_char_fan_A5_R_S = {hap_SecureRW_30, 0, CFG_DATA, 0, 0, 0, 0, 0, 0, 0, 0};

#if FAN_LINKED_SERVICES_ENABLE
/*fill the array with the pointer of linked services instance id.*/
const u16 * hFan_linked_svcs[] = {};
#endif

#if(FAN_IS_HIDDEN_SERVICE == 1)
const hap_service_desc_t hap_desc_service_fan_A5_R_S = {FAN_INST_NO+1, (0x02 + FAN_AS_PRIMARY_SERVICE), FAN_LINKED_SVCS_LENGTH, FAN_LINKED_SVCS};
#else
const hap_service_desc_t hap_desc_service_fan_A5_R_S = {FAN_INST_NO+1, (0x00 + FAN_AS_PRIMARY_SERVICE), FAN_LINKED_SVCS_LENGTH, FAN_LINKED_SVCS};
#endif

/* ------------------------------------
    Function Prototypes
   ------------------------------------ */
int FanActiveReadCallback(void *pp)
{
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanActiveWriteCallback(void *pp)
{
    blt_adv_set_global_state ();

    if (hap_char_boundary_check()) {  // 0~1
        assign_current_flash_char_value_addr();
    #if FAN_SERVICE_ENABLE
        FAN_STORE_CHAR_VALUE_T_HFAN_ACTIVE_RESTORE
    #endif
    } else {
		#if AIR_PURIFIER_SERVICE_ENABLE
		if(hFanActive == 0)
		{
			hFanCurrentFanState = 0;
			hCurrentAirPurifierState = 0;
			hAirPurifierActive = 0;
			if(indicate_handle_no_send_once_after_checkit(AIR_PURIFIER_HANDLE_NUM_HAIR_PURIFIER_ACTIVE) == 1)
				sleep_us(250);
		}
		#endif
        store_char_value_to_flash();
    }

    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanCurrentFanStateReadCallback(void *pp)
{
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanTargetFanStateReadCallback(void *pp)
{
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanTargetFanStateWriteCallback(void *pp)
{
    blt_adv_set_global_state ();

    if (hap_char_boundary_check()) {  // 0~1
        assign_current_flash_char_value_addr();
    #if FAN_SERVICE_ENABLE
        FAN_STORE_CHAR_VALUE_T_HFAN_TARGETFANSTATE_RESTORE
    #endif
    } else {
        store_char_value_to_flash();
    }

    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanRotationDirectionReadCallback(void *pp)
{
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanRotationDirectionWriteCallback(void *pp)
{
    blt_adv_set_global_state ();

    if (hap_char_boundary_check()) {  // 0~1
        assign_current_flash_char_value_addr();
    #if FAN_SERVICE_ENABLE
        FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONDIRECTION_RESTORE
    #endif
    } else {
        store_char_value_to_flash();
    }

    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanRotationSpeedReadCallback(void *pp)
{
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanRotationSpeedWriteCallback(void *pp)
{
    blt_adv_set_global_state ();

    if (hap_char_boundary_check()) {  // 0~100
        assign_current_flash_char_value_addr();
    #if FAN_SERVICE_ENABLE
        FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONSPEED_RESTORE
    #endif
    } else {
        store_char_value_to_flash();
    }

    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanSwingModeReadCallback(void *pp)
{
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanSwingModeWriteCallback(void *pp)
{
    blt_adv_set_global_state ();

    if (hap_char_boundary_check()) {  // 0~1
        assign_current_flash_char_value_addr();
    #if FAN_SERVICE_ENABLE
        FAN_STORE_CHAR_VALUE_T_HFAN_SWINGMODE_RESTORE
    #endif
    } else {
        store_char_value_to_flash();
    }

    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanLockPhysicalControlsReadCallback(void *pp)
{
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int FanLockPhysicalControlsWriteCallback(void *pp)
{
    blt_adv_set_global_state ();

    if (hap_char_boundary_check()) {  // 0~1
        assign_current_flash_char_value_addr();
    #if FAN_SERVICE_ENABLE
        FAN_STORE_CHAR_VALUE_T_HFAN_LOCKPHYSICALCONTROLS_RESTORE
    #endif
    } else {
        store_char_value_to_flash();
    }

    session_timeout_tick = clock_time () | 1;
    return 1;
}


int ccc_hFanActiveWriteCB(void *pp)
{
    static u16 ccc_hFanActive_pre = 0;

    if(ccc_hFanActive_pre != ccc_hFanActive)
    {
        if(ccc_hFanActive == 0)
        {
            ccc_hFanActive_pre = ccc_hFanActive;
            EventNotifyCNT--;
            indicate_handle_no_remove(FAN_HANDLE_NUM_HFAN_ACTIVE);
        }
        else
        {
            ccc_hFanActive_pre = ccc_hFanActive;
            EventNotifyCNT++;
            indicate_handle_no_reg(FAN_HANDLE_NUM_HFAN_ACTIVE);
        }
    }
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int ccc_hFanCurrentFanStateWriteCB(void *pp)
{
    static u16 ccc_hFanCurrentFanState_pre = 0;

    if(ccc_hFanCurrentFanState_pre != ccc_hFanCurrentFanState)
    {
        if(ccc_hFanCurrentFanState == 0)
        {
            ccc_hFanCurrentFanState_pre = ccc_hFanCurrentFanState;
            EventNotifyCNT--;
            indicate_handle_no_remove(FAN_HANDLE_NUM_HFAN_CURRENTFANSTATE);
        }
        else
        {
            ccc_hFanCurrentFanState_pre = ccc_hFanCurrentFanState;
            EventNotifyCNT++;
            indicate_handle_no_reg(FAN_HANDLE_NUM_HFAN_CURRENTFANSTATE);
        }
    }
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int ccc_hFanTargetFanStateWriteCB(void *pp)
{
    static u16 ccc_hFanTargetFanState_pre = 0;

    if(ccc_hFanTargetFanState_pre != ccc_hFanTargetFanState)
    {
        if(ccc_hFanTargetFanState == 0)
        {
            ccc_hFanTargetFanState_pre = ccc_hFanTargetFanState;
            EventNotifyCNT--;
            indicate_handle_no_remove(FAN_HANDLE_NUM_HFAN_TARGETFANSTATE);
        }
        else
        {
            ccc_hFanTargetFanState_pre = ccc_hFanTargetFanState;
            EventNotifyCNT++;
            indicate_handle_no_reg(FAN_HANDLE_NUM_HFAN_TARGETFANSTATE);
        }
    }
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int ccc_hFanRotationDirectionWriteCB(void *pp)
{
    static u16 ccc_hFanRotationDirection_pre = 0;

    if(ccc_hFanRotationDirection_pre != ccc_hFanRotationDirection)
    {
        if(ccc_hFanRotationDirection == 0)
        {
            ccc_hFanRotationDirection_pre = ccc_hFanRotationDirection;
            EventNotifyCNT--;
            indicate_handle_no_remove(FAN_HANDLE_NUM_HFAN_ROTATIONDIRECTION);
        }
        else
        {
            ccc_hFanRotationDirection_pre = ccc_hFanRotationDirection;
            EventNotifyCNT++;
            indicate_handle_no_reg(FAN_HANDLE_NUM_HFAN_ROTATIONDIRECTION);
        }
    }
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int ccc_hFanRotationSpeedWriteCB(void *pp)
{
    static u16 ccc_hFanRotationSpeed_pre = 0;

    if(ccc_hFanRotationSpeed_pre != ccc_hFanRotationSpeed)
    {
        if(ccc_hFanRotationSpeed == 0)
        {
            ccc_hFanRotationSpeed_pre = ccc_hFanRotationSpeed;
            EventNotifyCNT--;
            indicate_handle_no_remove(FAN_HANDLE_NUM_HFAN_ROTATIONSPEED);
        }
        else
        {
            ccc_hFanRotationSpeed_pre = ccc_hFanRotationSpeed;
            EventNotifyCNT++;
            indicate_handle_no_reg(FAN_HANDLE_NUM_HFAN_ROTATIONSPEED);
        }
    }
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int ccc_hFanSwingModeWriteCB(void *pp)
{
    static u16 ccc_hFanSwingMode_pre = 0;

    if(ccc_hFanSwingMode_pre != ccc_hFanSwingMode)
    {
        if(ccc_hFanSwingMode == 0)
        {
            ccc_hFanSwingMode_pre = ccc_hFanSwingMode;
            EventNotifyCNT--;
            indicate_handle_no_remove(FAN_HANDLE_NUM_HFAN_SWINGMODE);
        }
        else
        {
            ccc_hFanSwingMode_pre = ccc_hFanSwingMode;
            EventNotifyCNT++;
            indicate_handle_no_reg(FAN_HANDLE_NUM_HFAN_SWINGMODE);
        }
    }
    session_timeout_tick = clock_time () | 1;
    return 1;
}

int ccc_hFanLockPhysicalControlsWriteCB(void *pp)
{
    static u16 ccc_hFanLockPhysicalControls_pre = 0;

    if(ccc_hFanLockPhysicalControls_pre != ccc_hFanLockPhysicalControls)
    {
        if(ccc_hFanLockPhysicalControls == 0)
        {
            ccc_hFanLockPhysicalControls_pre = ccc_hFanLockPhysicalControls;
            EventNotifyCNT--;
            indicate_handle_no_remove(FAN_HANDLE_NUM_HFAN_LOCKPHYSICALCONTROLS);
        }
        else
        {
            ccc_hFanLockPhysicalControls_pre = ccc_hFanLockPhysicalControls;
            EventNotifyCNT++;
            indicate_handle_no_reg(FAN_HANDLE_NUM_HFAN_LOCKPHYSICALCONTROLS);
        }
    }
    session_timeout_tick = clock_time () | 1;
    return 1;
}


/* %% End Of File %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
