/********************************************************************************************************
 * @file     hk_FanService.h
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2016, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/
#ifndef _HK_FAN_SERVICE_H_
#define _HK_FAN_SERVICE_H_

#include "homekit_src/homekit_inc.h"

/* ------------------------------------
    Header Files
   ------------------------------------ */


/* ------------------------------------
    Macro Definitions
   ------------------------------------ */
#undef EXTERN

#ifdef _HK_FAN_SERVICE_C_
    #define EXTERN
#else
    #define EXTERN  extern
#endif

#define CHAR_FAN_SVC_SIGN_ENABLE      1
#if CHAR_FAN_SVC_SIGN_ENABLE
    #define FAN_AS_PRIMARY_SERVICE    	1//0	//for TCH064
    #define FAN_IS_HIDDEN_SERVICE     	0
    #define FAN_LINKED_SERVICES_ENABLE	0
    EXTERN const hap_characteristic_desc_t hap_desc_char_fan_A5_R_S;
    EXTERN const hap_service_desc_t hap_desc_service_fan_A5_R_S;
    EXTERN unsigned char VAR_FAN_UNKOWN;
#else
    #define FAN_AS_PRIMARY_SERVICE    	0
    #define FAN_IS_HIDDEN_SERVICE     	0
    #define FAN_LINKED_SERVICES_ENABLE	0
#endif


#define CHAR_FAN_CURRENT_FAN_STATE_ENABLE    	1
#define CHAR_FAN_TARGET_FAN_STATE_ENABLE     	1
#define CHAR_FAN_ROTATION_DIRECTION_ENABLE		1//0	//1:Only for TCH009, 0: for TCH008 & TCH064
#define CHAR_FAN_ROTATION_SPEED_ENABLE			0
#define CHAR_FAN_SWING_MODE_ENABLE				0
#define CHAR_FAN_LOCK_PHYSICAL_CONTROLS_ENABLE	0


#define FAN_ACTIVE_IND_ENABLE                	1

#define FAN_CURRENT_FAN_STATE_IND_ENABLE     	1
#define FAN_TARGET_FAN_STATE_IND_ENABLE      	1
#define FAN_ROTATION_DIRECTION_IND_ENABLE		1//0	//1:Only for TCH009, 0: for TCH008 & TCH064
#define FAN_ROTATION_SPEED_IND_ENABLE			0
#define FAN_SWING_MODE_IND_ENABLE				0
#define FAN_LOCK_PHYSICAL_CONTROLS_IND_ENABLE	0


#define FAN_ACTIVE_BRC_ENABLE                	1

#define FAN_CURRENT_FAN_STATE_BRC_ENABLE     	1
#define FAN_TARGET_FAN_STATE_BRC_ENABLE      	1
#define FAN_ROTATION_DIRECTION_BRC_ENABLE		1//0	//1:Only for TCH009, 0: for TCH008 & TCH064
#define FAN_ROTATION_SPEED_BRC_ENABLE			0
#define FAN_SWING_MODE_BRC_ENABLE				0
#define FAN_LOCK_PHYSICAL_CONTROLS_BRC_ENABLE	0


#define FAN_ACTIVE_NO      3
#if FAN_ACTIVE_IND_ENABLE
    #define FAN_ACTIVE_IND_DESC \
        {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hFanActive), ccc_hFanActiveWriteCB, 0},
    #define FAN_ACTIVE_IND_NO  1
#else
    #define FAN_ACTIVE_IND_DESC
    #define FAN_ACTIVE_IND_NO  0
#endif

#if CHAR_FAN_CURRENT_FAN_STATE_ENABLE
    #define FAN_CURRENT_FAN_STATE_NO   3
    #define CHAR_FAN_CURRENT_FAN_STATE_ATT_TABLE   \
            {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_Fan_CurrentFanState_R_S, 0},    \
            {0,ATT_PERMISSIONS_RDWR,16,sizeof(hFanCurrentFanState),0, (u8*)(charCurrentFanStateUUID), (u8*)&hFanCurrentFanState, 0, FanCurrentFanStateReadCallback}, \
                {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + FAN_INST_NO + 3), 0, 0}, \
                FAN_CURRENT_FAN_STATE_IND_DESC

    #if FAN_CURRENT_FAN_STATE_IND_ENABLE
        #define FAN_CURRENT_FAN_STATE_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hFanCurrentFanState), ccc_hFanCurrentFanStateWriteCB, 0},
        #define FAN_CURRENT_FAN_STATE_IND_NO  1
    #else
        #define FAN_CURRENT_FAN_STATE_IND_DESC
        #define FAN_CURRENT_FAN_STATE_IND_NO  0
    #endif
#else
    #define FAN_CURRENT_FAN_STATE_NO   0
    #define CHAR_FAN_CURRENT_FAN_STATE_ATT_TABLE
    #define FAN_CURRENT_FAN_STATE_IND_NO  0
#endif

#if CHAR_FAN_TARGET_FAN_STATE_ENABLE
    #define FAN_TARGET_FAN_STATE_NO   3
    #define CHAR_FAN_TARGET_FAN_STATE_ATT_TABLE   \
            {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_Fan_TargetFanState_R_S, 0},    \
            {0,ATT_PERMISSIONS_RDWR,16,sizeof(hFanTargetFanState),0, (u8*)(charTargetFanStateUUID), (u8*)&hFanTargetFanState, FanTargetFanStateWriteCallback, FanTargetFanStateReadCallback}, \
                {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + FAN_INST_NO + 4), 0, 0}, \
                FAN_TARGET_FAN_STATE_IND_DESC

    #if FAN_TARGET_FAN_STATE_IND_ENABLE
        #define FAN_TARGET_FAN_STATE_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hFanTargetFanState), ccc_hFanTargetFanStateWriteCB, 0},
        #define FAN_TARGET_FAN_STATE_IND_NO  1
    #else
        #define FAN_TARGET_FAN_STATE_IND_DESC
        #define FAN_TARGET_FAN_STATE_IND_NO  0
    #endif
#else
    #define FAN_TARGET_FAN_STATE_NO   0
    #define CHAR_FAN_TARGET_FAN_STATE_ATT_TABLE
    #define FAN_TARGET_FAN_STATE_IND_NO  0
#endif

#if CHAR_FAN_ROTATION_DIRECTION_ENABLE
    #define FAN_ROTATION_DIRECTION_NO 3
    #define CHAR_FAN_ROTATION_DIRECTION_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_Fan_RotationDirection_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof (hFanRotationDirection), 0, (u8*)(&charRotationDirectionUUID), (u8*)&hFanRotationDirection, FanRotationDirectionWriteCallback, FanRotationDirectionReadCallback},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + FAN_INST_NO + 5), 0, 0}, \
            FAN_ROTATION_DIRECTION_IND_DESC

    #if FAN_ROTATION_DIRECTION_IND_ENABLE
        #define FAN_ROTATION_DIRECTION_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hFanRotationDirection), ccc_hFanRotationDirectionWriteCB, 0},
        #define FAN_ROTATION_DIRECTION_IND_NO  1
    #else
        #define FAN_ROTATION_DIRECTION_IND_DESC
        #define FAN_ROTATION_DIRECTION_IND_NO  0
    #endif
#else
    #define FAN_ROTATION_DIRECTION_NO 0
    #define CHAR_FAN_ROTATION_DIRECTION_ATT_TABLE
    #define FAN_ROTATION_DIRECTION_IND_NO  0
#endif

#if CHAR_FAN_ROTATION_SPEED_ENABLE
    #define FAN_ROTATION_SPEED_NO 3
    #define CHAR_FAN_ROTATION_SPEED_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_Fan_RotationSpeed_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof (hFanRotationSpeed), 0, (u8*)(&charRotationSpeedUUID), (u8*)&hFanRotationSpeed, FanRotationSpeedWriteCallback, FanRotationSpeedReadCallback},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + FAN_INST_NO + 6), 0, 0}, \
            FAN_ROTATION_SPEED_IND_DESC

    #if FAN_ROTATION_SPEED_IND_ENABLE
        #define FAN_ROTATION_SPEED_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hFanRotationSpeed), ccc_hFanRotationSpeedWriteCB, 0},
        #define FAN_ROTATION_SPEED_IND_NO  1
    #else
        #define FAN_ROTATION_SPEED_IND_DESC
        #define FAN_ROTATION_SPEED_IND_NO  0
    #endif
#else
    #define FAN_ROTATION_SPEED_NO 0
    #define CHAR_FAN_ROTATION_SPEED_ATT_TABLE
    #define FAN_ROTATION_SPEED_IND_NO  0
#endif

#if CHAR_FAN_SWING_MODE_ENABLE
    #define FAN_SWING_MODE_NO   3
    #define CHAR_FAN_SWING_MODE_ATT_TABLE   \
            {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_Fan_SwingMode_R_S, 0},    \
            {0,ATT_PERMISSIONS_RDWR,16,sizeof(hFanSwingMode),0, (u8*)(charSwingModeUUID), (u8*)&hFanSwingMode, FanSwingModeWriteCallback, FanSwingModeReadCallback}, \
                {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + FAN_INST_NO + 7), 0, 0}, \
                FAN_SWING_MODE_IND_DESC

    #if FAN_SWING_MODE_IND_ENABLE
        #define FAN_SWING_MODE_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hFanSwingMode), ccc_hFanSwingModeWriteCB, 0},
        #define FAN_SWING_MODE_IND_NO  1
    #else
        #define FAN_SWING_MODE_IND_DESC
        #define FAN_SWING_MODE_IND_NO  0
    #endif
#else
    #define FAN_SWING_MODE_NO   0
    #define CHAR_FAN_SWING_MODE_ATT_TABLE
    #define FAN_SWING_MODE_IND_NO  0
#endif

#if CHAR_FAN_LOCK_PHYSICAL_CONTROLS_ENABLE
    #define FAN_LOCK_PHYSICAL_CONTROLS_NO   3
    #define CHAR_FAN_LOCK_PHYSICAL_CONTROLS_ATT_TABLE   \
            {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_Fan_LockPhysicalControls_R_S, 0},    \
            {0,ATT_PERMISSIONS_RDWR,16,sizeof(hFanLockPhysicalControls),0, (u8*)(charLockPhysicalControlsUUID), (u8*)&hFanLockPhysicalControls, FanLockPhysicalControlsWriteCallback, FanLockPhysicalControlsReadCallback}, \
                {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + FAN_INST_NO + 8), 0, 0}, \
                FAN_LOCK_PHYSICAL_CONTROLS_IND_DESC

    #if FAN_LOCK_PHYSICAL_CONTROLS_IND_ENABLE
        #define FAN_LOCK_PHYSICAL_CONTROLS_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hFanLockPhysicalControls), ccc_hFanLockPhysicalControlsWriteCB, 0},
        #define FAN_LOCK_PHYSICAL_CONTROLS_IND_NO  1
    #else
        #define FAN_LOCK_PHYSICAL_CONTROLS_IND_DESC
        #define FAN_LOCK_PHYSICAL_CONTROLS_IND_NO  0
    #endif
#else
    #define FAN_LOCK_PHYSICAL_CONTROLS_NO   0
    #define CHAR_FAN_LOCK_PHYSICAL_CONTROLS_ATT_TABLE
    #define FAN_LOCK_PHYSICAL_CONTROLS_IND_NO  0
#endif


#if CHAR_FAN_SVC_SIGN_ENABLE
    #define FAN_SVC_SIGN_NO   3
    #define CHAR_FAN_SVC_A5_SIGN_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteProp), (att_readwrite_callback_t)&hap_desc_char_fan_A5_R_S, (att_readwrite_callback_t)&hap_desc_service_fan_A5_R_S},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof (VAR_FAN_UNKOWN),0, (u8*)(HapServiceSignatureCharUUID), (u8*)&VAR_FAN_UNKOWN, 0, 0},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + FAN_INST_NO + 9), 0, 0},
#else
    #define FAN_SVC_SIGN_NO   0
    #define CHAR_FAN_SVC_A5_SIGN_TABLE
#endif

#define FAN_NO_DELTA    FAN_ACTIVE_IND_NO + FAN_CURRENT_FAN_STATE_IND_NO + FAN_TARGET_FAN_STATE_IND_NO \
						+ FAN_ROTATION_DIRECTION_IND_NO + FAN_ROTATION_SPEED_IND_NO + FAN_SWING_MODE_IND_NO \
						+ FAN_LOCK_PHYSICAL_CONTROLS_IND_NO
						
#define FAN_NO          9 + FAN_CURRENT_FAN_STATE_NO + FAN_TARGET_FAN_STATE_NO +  FAN_ROTATION_DIRECTION_NO \
						+ FAN_ROTATION_SPEED_NO + FAN_SWING_MODE_NO + FAN_LOCK_PHYSICAL_CONTROLS_NO \
						+ FAN_SVC_SIGN_NO
						
#define FAN_HANDLE_NUM (FAN_NO + FAN_NO_DELTA)


#define HOMEKIT_FAN_SERVICE_ATT_TABLE   \
    {FAN_HANDLE_NUM,ATT_PERMISSIONS_READ,2,sizeof(fanServiceUUID),sizeof(fanServiceUUID), (u8*)(&primaryServiceUUID), (u8*)(fanServiceUUID), 0, 0},   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readOnlyProp), 0, 0},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(serviceInstanceUUID), (u8*)(insts + FAN_INST_NO), 0, 0},   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteProp), (att_readwrite_callback_t)&hap_desc_char_NAME, 0},    \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof(hFanServiceName), 0, (u8*)(nameUUID), (u8*)(hFanServiceName), 0, HAPCommonSetSessionTimeoutReadCB},  \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + FAN_INST_NO + 1), 0, 0}, \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_Fan_Active_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,1,0, (u8*)(charActiveUUID), (u8*)&hFanActive, FanActiveWriteCallback, FanActiveReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + FAN_INST_NO + 2), 0, 0},  \
            FAN_ACTIVE_IND_DESC \
        CHAR_FAN_CURRENT_FAN_STATE_ATT_TABLE \
        CHAR_FAN_TARGET_FAN_STATE_ATT_TABLE \
        CHAR_FAN_ROTATION_DIRECTION_ATT_TABLE \
        CHAR_FAN_ROTATION_SPEED_ATT_TABLE \
        CHAR_FAN_SWING_MODE_ATT_TABLE \
        CHAR_FAN_LOCK_PHYSICAL_CONTROLS_ATT_TABLE \
        CHAR_FAN_SVC_A5_SIGN_TABLE


#define FAN_HANDLE_COMMON_NUM     8

#define FAN_HANDLE_NUM_HFAN_ACTIVE            	FAN_HANDLE_START_NUM +FAN_HANDLE_COMMON_NUM
#define FAN_HANDLE_NUM_HFAN_CURRENTFANSTATE   	FAN_HANDLE_NUM_HFAN_ACTIVE +FAN_ACTIVE_NO+FAN_ACTIVE_IND_NO
#define FAN_HANDLE_NUM_HFAN_TARGETFANSTATE    	FAN_HANDLE_NUM_HFAN_CURRENTFANSTATE +FAN_CURRENT_FAN_STATE_NO +FAN_CURRENT_FAN_STATE_IND_NO
#define FAN_HANDLE_NUM_HFAN_ROTATIONDIRECTION		FAN_HANDLE_NUM_HFAN_TARGETFANSTATE +FAN_TARGET_FAN_STATE_NO +FAN_TARGET_FAN_STATE_IND_NO
#define FAN_HANDLE_NUM_HFAN_ROTATIONSPEED    		FAN_HANDLE_NUM_HFAN_ROTATIONDIRECTION +FAN_ROTATION_DIRECTION_NO +FAN_ROTATION_DIRECTION_IND_NO
#define FAN_HANDLE_NUM_HFAN_SWINGMODE    			FAN_HANDLE_NUM_HFAN_ROTATIONSPEED +FAN_ROTATION_SPEED_NO +FAN_ROTATION_SPEED_IND_NO
#define FAN_HANDLE_NUM_HFAN_LOCKPHYSICALCONTROLS	FAN_HANDLE_NUM_HFAN_SWINGMODE +FAN_SWING_MODE_NO +FAN_SWING_MODE_IND_NO
#define FAN_HANDLE_NUM_THE_END


#define FAN_STORE_CHAR_VALUE_T_HFAN_ACTIVE                    u32 FanActive:1;    /* 0~1 */
#define FAN_STORE_CHAR_VALUE_T_HFAN_ACTIVE_STORE                  STORE_CHAR(FanActive,hFanActive)
#define FAN_STORE_CHAR_VALUE_T_HFAN_ACTIVE_RESTORE                RESTORE_CHAR(FanActive,hFanActive)

#define FAN_STORE_CHAR_VALUE_T_HFAN_CURRENTFANSTATE           u32 FanCurrentFanState:2;    /* 0~2 */
#define FAN_STORE_CHAR_VALUE_T_HFAN_CURRENTFANSTATE_STORE         STORE_CHAR(FanCurrentFanState,hFanCurrentFanState)
#define FAN_STORE_CHAR_VALUE_T_HFAN_CURRENTFANSTATE_RESTORE       RESTORE_CHAR(FanCurrentFanState,hFanCurrentFanState)

#define FAN_STORE_CHAR_VALUE_T_HFAN_TARGETFANSTATE            u32 FanTargetFanState:1;    /* 0~1 */
#define FAN_STORE_CHAR_VALUE_T_HFAN_TARGETFANSTATE_STORE          STORE_CHAR(FanTargetFanState,hFanTargetFanState)
#define FAN_STORE_CHAR_VALUE_T_HFAN_TARGETFANSTATE_RESTORE        RESTORE_CHAR(FanTargetFanState,hFanTargetFanState)

#define FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONDIRECTION         u32 FanRotationDirection:1;    /* 0~1 */
#define FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONDIRECTION_STORE       STORE_CHAR(FanRotationDirection,hFanRotationDirection)
#define FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONDIRECTION_RESTORE     RESTORE_CHAR(FanRotationDirection,hFanRotationDirection)

#define FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONSPEED             u32 FanRotationSpeed:1;    /* float */
#define FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONSPEED_STORE           STORE_CHAR(FanRotationSpeed,hFanRotationSpeed)
#define FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONSPEED_RESTORE         RESTORE_CHAR(FanRotationSpeed,hFanRotationSpeed)

#define FAN_STORE_CHAR_VALUE_T_HFAN_SWINGMODE                 u32 FanSwingMode:1;    /* 0~1 */
#define FAN_STORE_CHAR_VALUE_T_HFAN_SWINGMODE_STORE               STORE_CHAR(FanSwingMode,hFanSwingMode)
#define FAN_STORE_CHAR_VALUE_T_HFAN_SWINGMODE_RESTORE             RESTORE_CHAR(FanSwingMode,hFanSwingMode)

#define FAN_STORE_CHAR_VALUE_T_HFAN_LOCKPHYSICALCONTROLS      u32 FanLockPhysicalControls:1;    /* 0~1 */
#define FAN_STORE_CHAR_VALUE_T_HFAN_LOCKPHYSICALCONTROLS_STORE    STORE_CHAR(FanLockPhysicalControls,hFanLockPhysicalControls)
#define FAN_STORE_CHAR_VALUE_T_HFAN_LOCKPHYSICALCONTROLS_RESTORE  RESTORE_CHAR(FanLockPhysicalControls,hFanLockPhysicalControls)


#define FAN_STORE_CHAR_VALUE_T  \
                    FAN_STORE_CHAR_VALUE_T_HFAN_ACTIVE  \
                    FAN_STORE_CHAR_VALUE_T_HFAN_CURRENTFANSTATE \
					FAN_STORE_CHAR_VALUE_T_HFAN_TARGETFANSTATE \
					FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONDIRECTION \
					FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONSPEED \
					FAN_STORE_CHAR_VALUE_T_HFAN_SWINGMODE \
					FAN_STORE_CHAR_VALUE_T_HFAN_LOCKPHYSICALCONTROLS
	
#define FAN_STORE_CHAR_TO_FLASH  \
                    FAN_STORE_CHAR_VALUE_T_HFAN_ACTIVE_STORE  \
                    FAN_STORE_CHAR_VALUE_T_HFAN_CURRENTFANSTATE_STORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_TARGETFANSTATE_STORE \
					FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONDIRECTION_STORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONSPEED_STORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_SWINGMODE_STORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_LOCKPHYSICALCONTROLS_STORE 

#define FAN_RESTORE_CHAR_FROM_FLASH  \
                    FAN_STORE_CHAR_VALUE_T_HFAN_ACTIVE_RESTORE  \
                    FAN_STORE_CHAR_VALUE_T_HFAN_CURRENTFANSTATE_RESTORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_TARGETFANSTATE_RESTORE \
					FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONDIRECTION_RESTORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_ROTATIONSPEED_RESTORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_SWINGMODE_RESTORE \
                    FAN_STORE_CHAR_VALUE_T_HFAN_LOCKPHYSICALCONTROLS_RESTORE


/* ------------------------------------
    Type Definitions
   ------------------------------------ */


/* ------------------------------------
    Variables Definitions/Declarations
   ------------------------------------ */
EXTERN unsigned char hFanActive;
EXTERN unsigned char hFanCurrentFanState;
EXTERN unsigned char hFanTargetFanState;
EXTERN int hFanRotationDirection;
EXTERN int hFanRotationSpeed;
EXTERN unsigned char hFanSwingMode;
EXTERN unsigned char hFanLockPhysicalControls;

EXTERN unsigned short ccc_hFanActive;
EXTERN unsigned short ccc_hFanCurrentFanState;
EXTERN unsigned short ccc_hFanTargetFanState;
EXTERN unsigned short ccc_hFanRotationDirection;
EXTERN unsigned short ccc_hFanRotationSpeed;
EXTERN unsigned short ccc_hFanSwingMode;
EXTERN unsigned short ccc_hFanLockPhysicalControls;

#if FAN_ACTIVE_BRC_ENABLE
    #define BC_PARA_FAN_ACTIVE ((u8*)&bc_para_hFanActive)
    EXTERN unsigned char bc_para_hFanActive;
#else
    #define BC_PARA_FAN_ACTIVE 0
#endif

#if FAN_CURRENT_FAN_STATE_BRC_ENABLE
    #define BC_PARA_FAN_CURRENT_FAN_STATE ((u8*)&bc_para_hFanCurrentFanState)
    EXTERN unsigned char bc_para_hFanCurrentFanState;
#else
    #define BC_PARA_FAN_CURRENT_FAN_STATE 0
#endif

#if FAN_TARGET_FAN_STATE_BRC_ENABLE
    #define BC_PARA_FAN_TARGET_FAN_STATE ((u8*)&bc_para_hFanTargetFanState)
    EXTERN unsigned char bc_para_hFanTargetFanState;
#else
    #define BC_PARA_FAN_TARGET_FAN_STATE 0
#endif

#if FAN_ROTATION_DIRECTION_BRC_ENABLE
    #define BC_PARA_FAN_ROTATION_DIRECTION ((u8*)&bc_para_hFanRotationDirection)
    EXTERN unsigned char bc_para_hFanRotationDirection;
#else
    #define BC_PARA_FAN_ROTATION_DIRECTION 0
#endif

#if FAN_ROTATION_SPEED_BRC_ENABLE
    #define BC_PARA_FAN_ROTATION_SPEED ((u8*)&bc_para_hFanRotationSpeed)
    EXTERN unsigned char bc_para_hFanRotationSpeed;
#else
    #define BC_PARA_FAN_ROTATION_SPEED 0
#endif

#if FAN_SWING_MODE_BRC_ENABLE
    #define BC_PARA_FAN_SWING_MODE ((u8*)&bc_para_hFanSwingMode)
    EXTERN unsigned char bc_para_hFanSwingMode;
#else
    #define BC_PARA_FAN_SWING_MODE 0
#endif

#if FAN_LOCK_PHYSICAL_CONTROLS_BRC_ENABLE
    #define BC_PARA_FAN_LOCK_PHYSICAL_CONTROLS ((u8*)&bc_para_hFanLockPhysicalControls)
    EXTERN unsigned char bc_para_hFanLockPhysicalControls;
#else
    #define BC_PARA_FAN_LOCK_PHYSICAL_CONTROLS 0
#endif

#if FAN_LINKED_SERVICES_ENABLE
	#define FAN_LINKED_SVCS			hFan_linked_svcs
	#define FAN_LINKED_SVCS_LENGTH 	(sizeof(hFan_linked_svcs)/sizeof(size_t)*2)
	EXTERN const u16 * hFan_linked_svcs[];
#else
	#define FAN_LINKED_SVCS			0
	#define FAN_LINKED_SVCS_LENGTH 	0
#endif

EXTERN const u8 hFanServiceName[10];

EXTERN const hap_characteristic_desc_t hap_desc_char_Fan_Active_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_Fan_CurrentFanState_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_Fan_TargetFanState_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_Fan_RotationDirection_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_Fan_RotationSpeed_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_Fan_SwingMode_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_Fan_LockPhysicalControls_R_S;

/* ------------------------------------
    Function Prototypes
   ------------------------------------ */
EXTERN int FanActiveReadCallback(void *pp);
EXTERN int FanActiveWriteCallback(void *pp);
EXTERN int FanCurrentFanStateReadCallback(void *pp);
EXTERN int FanTargetFanStateReadCallback(void *pp);
EXTERN int FanTargetFanStateWriteCallback(void *pp);
EXTERN int FanRotationDirectionReadCallback(void *pp);
EXTERN int FanRotationDirectionWriteCallback(void *pp);
EXTERN int FanRotationSpeedReadCallback(void *pp);
EXTERN int FanRotationSpeedWriteCallback(void *pp);
EXTERN int FanSwingModeReadCallback(void *pp);
EXTERN int FanSwingModeWriteCallback(void *pp);
EXTERN int FanLockPhysicalControlsReadCallback(void *pp);
EXTERN int FanLockPhysicalControlsWriteCallback(void *pp);
	
EXTERN int ccc_hFanActiveWriteCB(void *pp);
EXTERN int ccc_hFanCurrentFanStateWriteCB(void *pp);
EXTERN int ccc_hFanTargetFanStateWriteCB(void *pp);
EXTERN int ccc_hFanRotationDirectionWriteCB(void *pp);
EXTERN int ccc_hFanRotationSpeedWriteCB(void *pp);
EXTERN int ccc_hFanSwingModeWriteCB(void *pp);
EXTERN int ccc_hFanLockPhysicalControlsWriteCB(void *pp);

#endif /* _HK_FAN_SERVICE_H_ */

/* %% End Of File %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
