/********************************************************************************************************
 * @file     hk_SensorAirQualityService.h
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2016, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/
#ifndef _HK_SENSOR_AIR_QUALITY_SERVICE_H_
#define _HK_SENSOR_AIR_QUALITY_SERVICE_H_

#include "homekit_src/homekit_inc.h"

/* ------------------------------------
    Header Files
   ------------------------------------ */


/* ------------------------------------
    Macro Definitions
   ------------------------------------ */
#undef EXTERN

#ifdef _HK_SENSOR_AIR_QUALITY_SERVICE_C_
    #define EXTERN
#else
    #define EXTERN  extern
#endif

#define CHAR_SENSOR_AIR_QUALITY_SVC_SIGN_ENABLE      1
#if CHAR_SENSOR_AIR_QUALITY_SVC_SIGN_ENABLE
    #define SENSOR_AIR_QUALITY_AS_PRIMARY_SERVICE    	1
    #define SENSOR_AIR_QUALITY_IS_HIDDEN_SERVICE     	0
    #define SENSOR_AIR_QUALITY_LINKED_SERVICES_ENABLE	0
    EXTERN const hap_characteristic_desc_t hap_desc_char_sensor_air_quality_A5_R_S;
    EXTERN const hap_service_desc_t hap_desc_service_sensor_air_quality_A5_R_S;
    EXTERN unsigned char VAR_SENSOR_AIR_QUALITY_UNKOWN;
#else
    #define SENSOR_AIR_QUALITY_AS_PRIMARY_SERVICE    	0
    #define SENSOR_AIR_QUALITY_IS_HIDDEN_SERVICE     	0
    #define SENSOR_AIR_QUALITY_LINKED_SERVICES_ENABLE	0
#endif


#define CHAR_SENSORAIRQUALITY_OZONE_DENSITY_NO_ENABLE               0
#define CHAR_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO_ENABLE    0
#define CHAR_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO_ENABLE     0
#define CHAR_SENSORAIRQUALITY_PM2_5_DENSITY_NO_ENABLE               0
#define CHAR_SENSORAIRQUALITY_PM10_DENSITY_NO_ENABLE                0
#define CHAR_SENSORAIRQUALITY_VOC_DENSITY_NO_ENABLE                 0
#define CHAR_SENSORAIRQUALITY_STATUSACTIVE_NO_ENABLE                0
#define CHAR_SENSORAIRQUALITY_STATUSFAULT_NO_ENABLE                 0
#define CHAR_SENSORAIRQUALITY_STATUSTAMPERED_NO_ENABLE              0
#define CHAR_SENSORAIRQUALITY_STATUSLOWBATTERY_NO_ENABLE            0


#define SENSORAIRQUALITY_INDICATOR_IND_ENABLE                   1

#define SENSORAIRQUALITY_OZONE_DENSITY_IND_ENABLE               0
#define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_ENABLE    0
#define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_ENABLE     0
#define SENSORAIRQUALITY_PM2_5_DENSITY_IND_ENABLE               0
#define SENSORAIRQUALITY_PM10_DENSITY_IND_ENABLE                0
#define SENSORAIRQUALITY_VOC_DENSITY_IND_ENABLE                 0
#define SENSORAIRQUALITY_STATUSACTIVE_IND_ENABLE                0
#define SENSORAIRQUALITY_STATUSFAULT_IND_ENABLE                 0
#define SENSORAIRQUALITY_STATUSTAMPERED_IND_ENABLE              0
#define SENSORAIRQUALITY_STATUSLOWBATTERY_IND_ENABLE            0


#define SENSORAIRQUALITY_INDICATOR_BRC_ENABLE                   1

#define SENSORAIRQUALITY_OZONE_DENSITY_BRC_ENABLE               0
#define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_BRC_ENABLE    0
#define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_BRC_ENABLE     0
#define SENSORAIRQUALITY_PM2_5_DENSITY_BRC_ENABLE               0
#define SENSORAIRQUALITY_PM10_DENSITY_BRC_ENABLE                0
#define SENSORAIRQUALITY_VOC_DENSITY_BRC_ENABLE                 0
#define SENSORAIRQUALITY_STATUSACTIVE_BRC_ENABLE                0
#define SENSORAIRQUALITY_STATUSFAULT_BRC_ENABLE                 0
#define SENSORAIRQUALITY_STATUSTAMPERED_BRC_ENABLE              0
#define SENSORAIRQUALITY_STATUSLOWBATTERY_BRC_ENABLE            0


#define SENSORAIRQUALITY_INDICATOR_NO 3
#if SENSORAIRQUALITY_INDICATOR_IND_ENABLE
    #define SENSORAIRQUALITY_INDICATOR_IND_DESC \
        {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_Indicator), ccc_hSensorAirQuality_IndicatorWriteCB, 0},
    #define SENSORAIRQUALITY_INDICATOR_IND_NO  1
#else
    #define SENSORAIRQUALITY_INDICATOR_IND_DESC
    #define SENSORAIRQUALITY_INDICATOR_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_OZONE_DENSITY_NO_ENABLE
    #define SENSORAIRQUALITY_OZONE_DENSITY_NO 3
    #define CHAR_SENSORAIRQUALITY_OZONE_DENSITY_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_OzoneDensity_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_OzoneDensity),0, (u8*)(charOzoneDensityUUID), (u8*)&hSensor_Air_Quality_OzoneDensity, 0, hSensor_Air_Quality_OzoneDensityReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 3), 0, 0},   \
            SENSORAIRQUALITY_OZONE_DENSITY_IND_DESC

    #if SENSORAIRQUALITY_OZONE_DENSITY_IND_ENABLE
        #define SENSORAIRQUALITY_OZONE_DENSITY_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_OzoneDensity), ccc_hSensorAirQuality_OzoneDensityWriteCB, 0},
        #define SENSORAIRQUALITY_OZONE_DENSITY_IND_NO  1
    #else
        #define SENSORAIRQUALITY_OZONE_DENSITY_IND_DESC
        #define SENSORAIRQUALITY_OZONE_DENSITY_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_OZONE_DENSITY_NO 0
    #define CHAR_SENSORAIRQUALITY_OZONE_DENSITY_NO_ATT_TABLE
    #define SENSORAIRQUALITY_OZONE_DENSITY_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO_ENABLE
    #define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO 3
    #define CHAR_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_NitrogenDioxideDensity_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_NitrogenDioxideDensity),0, (u8*)(charNitrogenDioxideDensityUUID), (u8*)&hSensor_Air_Quality_NitrogenDioxideDensity, 0, hSensor_Air_Quality_NitrogenDioxideDensityReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 4), 0, 0},   \
            SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_DESC

    #if SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_ENABLE
        #define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_NitrogenDioxideDensity), ccc_hSensorAirQuality_NitrogenDioxideDensityWriteCB, 0},
        #define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_NO  1
    #else
        #define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_DESC
        #define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO 0
    #define CHAR_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO_ATT_TABLE
    #define SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO_ENABLE
    #define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO 3
    #define CHAR_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_SulphurDioxideDensity_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_SulphurDioxideDensity),0, (u8*)(charSulphurDioxideDensityUUID), (u8*)&hSensor_Air_Quality_SulphurDioxideDensity, 0, hSensor_Air_Quality_SulphurDioxideDensityReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 5), 0, 0},   \
            SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_DESC

    #if SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_ENABLE
        #define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_SulphurDioxideDensity), ccc_hSensorAirQuality_SulphurDioxideDensityWriteCB, 0},
        #define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_NO  1
    #else
        #define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_DESC
        #define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO 0
    #define CHAR_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO_ATT_TABLE
    #define SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_PM2_5_DENSITY_NO_ENABLE
    #define SENSORAIRQUALITY_PM2_5_DENSITY_NO 3
    #define CHAR_SENSORAIRQUALITY_PM2_5_DENSITY_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_PM2_5Density_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_PM2_5Density),0, (u8*)(charPM2_5DensityUUID), (u8*)&hSensor_Air_Quality_PM2_5Density, 0, hSensor_Air_Quality_PM2_5DensityReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 6), 0, 0},   \
            SENSORAIRQUALITY_PM2_5_DENSITY_IND_DESC

    #if SENSORAIRQUALITY_PM2_5_DENSITY_IND_ENABLE
        #define SENSORAIRQUALITY_PM2_5_DENSITY_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_PM2_5Density), ccc_hSensorAirQuality_PM2_5DensityWriteCB, 0},
        #define SENSORAIRQUALITY_PM2_5_DENSITY_IND_NO  1
    #else
        #define SENSORAIRQUALITY_PM2_5_DENSITY_IND_DESC
        #define SENSORAIRQUALITY_PM2_5_DENSITY_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_PM2_5_DENSITY_NO 0
    #define CHAR_SENSORAIRQUALITY_PM2_5_DENSITY_NO_ATT_TABLE
    #define SENSORAIRQUALITY_PM2_5_DENSITY_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_PM10_DENSITY_NO_ENABLE
    #define SENSORAIRQUALITY_PM10_DENSITY_NO 3
    #define CHAR_SENSORAIRQUALITY_PM10_DENSITY_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_PM10Density_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_PM10Density),0, (u8*)(charPM10DensityUUID), (u8*)&hSensor_Air_Quality_PM10Density, 0, hSensor_Air_Quality_PM10DensityReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 7), 0, 0},   \
            SENSORAIRQUALITY_PM10_DENSITY_IND_DESC

    #if SENSORAIRQUALITY_PM10_DENSITY_IND_ENABLE
        #define SENSORAIRQUALITY_PM10_DENSITY_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_PM10Density), ccc_hSensorAirQuality_PM10DensityWriteCB, 0},
        #define SENSORAIRQUALITY_PM10_DENSITY_IND_NO  1
    #else
        #define SENSORAIRQUALITY_PM10_DENSITY_IND_DESC
        #define SENSORAIRQUALITY_PM10_DENSITY_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_PM10_DENSITY_NO 0
    #define CHAR_SENSORAIRQUALITY_PM10_DENSITY_NO_ATT_TABLE
    #define SENSORAIRQUALITY_PM10_DENSITY_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_VOC_DENSITY_NO_ENABLE
    #define SENSORAIRQUALITY_VOC_DENSITY_NO 3
    #define CHAR_SENSORAIRQUALITY_VOC_DENSITY_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_VOCDensity_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_VOCDensity),0, (u8*)(charVOCDensityUUID), (u8*)&hSensor_Air_Quality_VOCDensity, 0, hSensor_Air_Quality_VOCDensityReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 8), 0, 0},   \
            SENSORAIRQUALITY_VOC_DENSITY_IND_DESC

    #if SENSORAIRQUALITY_VOC_DENSITY_IND_ENABLE
        #define SENSORAIRQUALITY_VOC_DENSITY_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_VOCDensity), ccc_hSensorAirQuality_VOCDensityWriteCB, 0},
        #define SENSORAIRQUALITY_VOC_DENSITY_IND_NO  1
    #else
        #define SENSORAIRQUALITY_VOC_DENSITY_IND_DESC
        #define SENSORAIRQUALITY_VOC_DENSITY_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_VOC_DENSITY_NO 0
    #define CHAR_SENSORAIRQUALITY_VOC_DENSITY_NO_ATT_TABLE
    #define SENSORAIRQUALITY_VOC_DENSITY_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_STATUSACTIVE_NO_ENABLE
    #define SENSORAIRQUALITY_STATUSACTIVE_NO 3
    #define CHAR_SENSORAIRQUALITY_STATUSACTIVE_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_StatusActive_R_S, 0},    \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_StatusActive),0, (u8*)(charStatusActiveUUID), (u8*)&hSensor_Air_Quality_StatusActive, 0, hSensor_Air_Quality_StatusActiveReadCallback},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 9), 0, 0},   \
            SENSORAIRQUALITY_STATUSACTIVE_IND_DESC

    #if SENSORAIRQUALITY_STATUSACTIVE_IND_ENABLE
        #define SENSORAIRQUALITY_STATUSACTIVE_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_StatusActive), ccc_hSensorAirQuality_StatusActiveWriteCB, 0},
        #define SENSORAIRQUALITY_STATUSACTIVE_IND_NO  1
    #else
        #define SENSORAIRQUALITY_STATUSACTIVE_IND_DESC
        #define SENSORAIRQUALITY_STATUSACTIVE_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_STATUSACTIVE_NO 0
    #define CHAR_SENSORAIRQUALITY_STATUSACTIVE_NO_ATT_TABLE
    #define SENSORAIRQUALITY_STATUSACTIVE_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_STATUSFAULT_NO_ENABLE
    #define SENSORAIRQUALITY_STATUSFAULT_NO 3
    #define CHAR_SENSORAIRQUALITY_STATUSFAULT_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_StatusFault_R_S, 0}, \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_StatusFault),0, (u8*)(charStatusFaultUUID), (u8*)&hSensor_Air_Quality_StatusFault, 0, hSensor_Air_Quality_StatusFaultReadCallback},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 10), 0, 0},   \
            SENSORAIRQUALITY_STATUSFAULT_IND_DESC

    #if SENSORAIRQUALITY_STATUSFAULT_IND_ENABLE
        #define SENSORAIRQUALITY_STATUSFAULT_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_StatusFault), ccc_hSensorAirQuality_StatusFaultWriteCB, 0},
        #define SENSORAIRQUALITY_STATUSFAULT_IND_NO  1
    #else
        #define SENSORAIRQUALITY_STATUSFAULT_IND_DESC
        #define SENSORAIRQUALITY_STATUSFAULT_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_STATUSFAULT_NO 0
    #define CHAR_SENSORAIRQUALITY_STATUSFAULT_NO_ATT_TABLE
    #define SENSORAIRQUALITY_STATUSFAULT_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_STATUSTAMPERED_NO_ENABLE
    #define SENSORAIRQUALITY_STATUSTAMPERED_NO 3
    #define CHAR_SENSORAIRQUALITY_STATUSTAMPERED_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_StatusTampered_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_StatusTampered),0, (u8*)(charStatusTamperedUUID), (u8*)&hSensor_Air_Quality_StatusTampered, 0, hSensor_Air_Quality_StatusTamperedReadCallback},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 11), 0, 0},   \
            SENSORAIRQUALITY_STATUSTAMPERED_IND_DESC

    #if SENSORAIRQUALITY_STATUSTAMPERED_IND_ENABLE
        #define SENSORAIRQUALITY_STATUSTAMPERED_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_StatusTampered), ccc_hSensorAirQuality_StatusTamperedWriteCB, 0},
        #define SENSORAIRQUALITY_STATUSTAMPERED_IND_NO  1
    #else
        #define SENSORAIRQUALITY_STATUSTAMPERED_IND_DESC
        #define SENSORAIRQUALITY_STATUSTAMPERED_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_STATUSTAMPERED_NO 0
    #define CHAR_SENSORAIRQUALITY_STATUSTAMPERED_NO_ATT_TABLE
    #define SENSORAIRQUALITY_STATUSTAMPERED_IND_NO  0
#endif

#if CHAR_SENSORAIRQUALITY_STATUSLOWBATTERY_NO_ENABLE
    #define SENSORAIRQUALITY_STATUSLOWBATTERY_NO 3
    #define CHAR_SENSORAIRQUALITY_STATUSLOWBATTERY_NO_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_StatusLowBattery_R_S, 0},    \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_StatusLowBattery),0, (u8*)(charStatusLowBatteryUUID), (u8*)&hSensor_Air_Quality_StatusLowBattery, 0, hSensor_Air_Quality_StatusLowBatteryReadCallback},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 12), 0, 0},   \
            SENSORAIRQUALITY_STATUSLOWBATTERY_IND_DESC

    #if SENSORAIRQUALITY_STATUSLOWBATTERY_IND_ENABLE
        #define SENSORAIRQUALITY_STATUSLOWBATTERY_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hSensorAirQuality_StatusLowBattery), ccc_hSensorAirQuality_StatusLowBatteryWriteCB, 0},
        #define SENSORAIRQUALITY_STATUSLOWBATTERY_IND_NO  1
    #else
        #define SENSORAIRQUALITY_STATUSLOWBATTERY_IND_DESC
        #define SENSORAIRQUALITY_STATUSLOWBATTERY_IND_NO  0
    #endif
#else
    #define SENSORAIRQUALITY_STATUSLOWBATTERY_NO 0
    #define CHAR_SENSORAIRQUALITY_STATUSLOWBATTERY_NO_ATT_TABLE
    #define SENSORAIRQUALITY_STATUSLOWBATTERY_IND_NO  0
#endif

#if CHAR_SENSOR_AIR_QUALITY_SVC_SIGN_ENABLE
#define CHAR_SENSOR_AIR_QUALITY_SVC_A5_SIGN_TABLE   \
    {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteProp), (att_readwrite_callback_t)&hap_desc_char_sensor_air_quality_A5_R_S, (att_readwrite_callback_t)&hap_desc_service_sensor_air_quality_A5_R_S},  \
    {0,ATT_PERMISSIONS_RDWR,16,sizeof (VAR_SENSOR_AIR_QUALITY_UNKOWN),0, (u8*)(HapServiceSignatureCharUUID), (u8*)&VAR_SENSOR_AIR_QUALITY_UNKOWN, 0, 0},    \
        {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 13), 0, 0},
#define SENSOR_AIR_QUALITY_SVC_SIGN_NO   3
#else
#define CHAR_SENSOR_AIR_QUALITY_SVC_A5_SIGN_TABLE
#define SENSOR_AIR_QUALITY_SVC_SIGN_NO   0
#endif


#define SENSOR_AIR_QUALITY_NO_DELTA SENSORAIRQUALITY_INDICATOR_IND_NO  \
                                    +SENSORAIRQUALITY_OZONE_DENSITY_IND_NO  \
                                    +SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_NO  \
                                    +SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_NO  \
                                    +SENSORAIRQUALITY_PM2_5_DENSITY_IND_NO  \
                                    +SENSORAIRQUALITY_PM10_DENSITY_IND_NO  \
                                    +SENSORAIRQUALITY_VOC_DENSITY_IND_NO  \
                                    +SENSORAIRQUALITY_STATUSACTIVE_IND_NO  \
                                    +SENSORAIRQUALITY_STATUSFAULT_IND_NO  \
                                    +SENSORAIRQUALITY_STATUSTAMPERED_IND_NO  \
                                    +SENSORAIRQUALITY_STATUSLOWBATTERY_IND_NO

#define SENSOR_AIR_QUALITY_NO       6 +SENSORAIRQUALITY_INDICATOR_NO  \
                                    +SENSORAIRQUALITY_OZONE_DENSITY_NO  \
                                    +SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO  \
                                    +SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO  \
                                    +SENSORAIRQUALITY_PM2_5_DENSITY_NO  \
                                    +SENSORAIRQUALITY_PM10_DENSITY_NO  \
                                    +SENSORAIRQUALITY_VOC_DENSITY_NO  \
                                    +SENSORAIRQUALITY_STATUSACTIVE_NO  \
                                    +SENSORAIRQUALITY_STATUSFAULT_NO  \
                                    +SENSORAIRQUALITY_STATUSTAMPERED_NO  \
                                    +SENSORAIRQUALITY_STATUSLOWBATTERY_NO  \
                                    +SENSOR_AIR_QUALITY_SVC_SIGN_NO

#define SENSOR_AIR_QUALITY_HANDLE_NUM (SENSOR_AIR_QUALITY_NO + SENSOR_AIR_QUALITY_NO_DELTA)


#define HOMEKIT_SENSOR_AIR_QUALITY_SERVICE_ATT_TABLE    \
    {SENSOR_AIR_QUALITY_HANDLE_NUM,ATT_PERMISSIONS_READ,2,sizeof(sensor_air_qualityServiceUUID),sizeof(sensor_air_qualityServiceUUID), (u8*)(&primaryServiceUUID), (u8*)(sensor_air_qualityServiceUUID), 0, 0},    \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readOnlyProp), 0, 0},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(serviceInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO), 0, 0},    \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteProp), (att_readwrite_callback_t)&hap_desc_char_NAME, 0},    \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof(hSensor_Air_QualityServiceName), 0, (u8*)(nameUUID), (u8*)(hSensor_Air_QualityServiceName), 0, HAPCommonSetSessionTimeoutReadCB},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 1), 0, 0},  \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_hSensor_Air_Quality_Indicator_R_S, 0},   \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hSensor_Air_Quality_Indicator),0, (u8*)(charAirQualityIndicatorUUID), (u8*)&hSensor_Air_Quality_Indicator, 0, hSensor_Air_Quality_IndicatorReadCallback},  \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + SENSOR_AIR_QUALITY_INST_NO + 2), 0, 0},   \
            SENSORAIRQUALITY_INDICATOR_IND_DESC \
        CHAR_SENSORAIRQUALITY_OZONE_DENSITY_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_PM2_5_DENSITY_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_PM10_DENSITY_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_VOC_DENSITY_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_STATUSACTIVE_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_STATUSFAULT_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_STATUSTAMPERED_NO_ATT_TABLE  \
        CHAR_SENSORAIRQUALITY_STATUSLOWBATTERY_NO_ATT_TABLE  \
        CHAR_SENSOR_AIR_QUALITY_SVC_A5_SIGN_TABLE


#define SENSORAIRQUALITY_HANDLE_COMMON_NUM     8

#define SENSORAIRQUALITY_HANDLE_NUM_INDICATOR                   SENSOR_AIR_QUALITY_HANDLE_START_NUM +SENSORAIRQUALITY_HANDLE_COMMON_NUM
#define SENSORAIRQUALITY_HANDLE_NUM_OZONE_DENSITY               SENSORAIRQUALITY_HANDLE_NUM_INDICATOR +SENSORAIRQUALITY_INDICATOR_NO +SENSORAIRQUALITY_INDICATOR_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_NITROGEN_DIOXIDE_DENSITY    SENSORAIRQUALITY_HANDLE_NUM_OZONE_DENSITY +SENSORAIRQUALITY_OZONE_DENSITY_NO +SENSORAIRQUALITY_OZONE_DENSITY_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_SULPHUR_DIOXIDE_DENSITY     SENSORAIRQUALITY_HANDLE_NUM_NITROGEN_DIOXIDE_DENSITY +SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO +SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_PM2_5_DENSITY               SENSORAIRQUALITY_HANDLE_NUM_SULPHUR_DIOXIDE_DENSITY +SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO +SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_PM10_DENSITY                SENSORAIRQUALITY_HANDLE_NUM_PM2_5_DENSITY +SENSORAIRQUALITY_PM2_5_DENSITY_NO +SENSORAIRQUALITY_PM2_5_DENSITY_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_VOC_DENSITY                 SENSORAIRQUALITY_HANDLE_NUM_PM10_DENSITY +SENSORAIRQUALITY_PM10_DENSITY_NO +SENSORAIRQUALITY_PM10_DENSITY_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_STATUSACTIVE                SENSORAIRQUALITY_HANDLE_NUM_VOC_DENSITY +SENSORAIRQUALITY_VOC_DENSITY_NO +SENSORAIRQUALITY_VOC_DENSITY_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_STATUSFAULT                 SENSORAIRQUALITY_HANDLE_NUM_STATUSACTIVE +SENSORAIRQUALITY_STATUSACTIVE_NO +SENSORAIRQUALITY_STATUSACTIVE_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_STATUSTAMPERED              SENSORAIRQUALITY_HANDLE_NUM_STATUSFAULT +SENSORAIRQUALITY_STATUSFAULT_NO +SENSORAIRQUALITY_STATUSFAULT_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_STATUSLOWBATTERY            SENSORAIRQUALITY_HANDLE_NUM_STATUSTAMPERED +SENSORAIRQUALITY_STATUSTAMPERED_NO +SENSORAIRQUALITY_STATUSTAMPERED_IND_NO
#define SENSORAIRQUALITY_HANDLE_NUM_THE_END


#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_INDICATOR                  u32 Sensor_Air_Quality_Indicator:3; /* 0~5 */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_INDICATOR_STORE                STORE_CHAR(Sensor_Air_Quality_Indicator,hSensor_Air_Quality_Indicator)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_INDICATOR_RESTORE              RESTORE_CHAR(Sensor_Air_Quality_Indicator,hSensor_Air_Quality_Indicator)

#if CHAR_SENSORAIRQUALITY_OZONE_DENSITY_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY              u32 Sensor_Air_Quality_OzoneDensity;    /* float */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY_STORE            STORE_CHAR(Sensor_Air_Quality_OzoneDensity,hSensor_Air_Quality_OzoneDensity)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY_RESTORE          RESTORE_CHAR(Sensor_Air_Quality_OzoneDensity,hSensor_Air_Quality_OzoneDensity)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY       u32 Sensor_Air_Quality_NitrogenDioxideDensity;    /* float */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY_STORE     STORE_CHAR(Sensor_Air_Quality_NitrogenDioxideDensity,hSensor_Air_Quality_NitrogenDioxideDensity)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY_RESTORE   RESTORE_CHAR(Sensor_Air_Quality_NitrogenDioxideDensity,hSensor_Air_Quality_NitrogenDioxideDensity)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY        u32 Sensor_Air_Quality_SulphurDioxideDensity;    /* float */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY_STORE      STORE_CHAR(Sensor_Air_Quality_SulphurDioxideDensity,hSensor_Air_Quality_SulphurDioxideDensity)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY_RESTORE    RESTORE_CHAR(Sensor_Air_Quality_SulphurDioxideDensity,hSensor_Air_Quality_SulphurDioxideDensity)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_PM2_5_DENSITY_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY              u32 Sensor_Air_Quality_PM2_5Density;    /* float */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY_STORE            STORE_CHAR(Sensor_Air_Quality_PM2_5Density,hSensor_Air_Quality_PM2_5Density)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY_RESTORE          RESTORE_CHAR(Sensor_Air_Quality_PM2_5Density,hSensor_Air_Quality_PM2_5Density)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_PM10_DENSITY_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY               u32 Sensor_Air_Quality_PM10Density;    /* float */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY_STORE             STORE_CHAR(Sensor_Air_Quality_PM10Density,hSensor_Air_Quality_PM10Density)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY_RESTORE           RESTORE_CHAR(Sensor_Air_Quality_PM10Density,hSensor_Air_Quality_PM10Density)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_VOC_DENSITY_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY                u32 Sensor_Air_Quality_VOCDensity;    /* float */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY_STORE              STORE_CHAR(Sensor_Air_Quality_VOCDensity,hSensor_Air_Quality_VOCDensity)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY_RESTORE            RESTORE_CHAR(Sensor_Air_Quality_VOCDensity,hSensor_Air_Quality_VOCDensity)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_STATUSACTIVE_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE               u32 Sensor_Air_Quality_StatusActive:1;    /* 0~1 */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE_STORE             STORE_CHAR(Sensor_Air_Quality_StatusActive,hSensor_Air_Quality_StatusActive)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE_RESTORE           RESTORE_CHAR(Sensor_Air_Quality_StatusActive,hSensor_Air_Quality_StatusActive)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_STATUSFAULT_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT                u32 Sensor_Air_Quality_StatusFault:1;   /* 0~1 */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT_STORE              STORE_CHAR(Sensor_Air_Quality_StatusFault,hSensor_Air_Quality_StatusFault)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT_RESTORE            RESTORE_CHAR(Sensor_Air_Quality_StatusFault,hSensor_Air_Quality_StatusFault)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_STATUSTAMPERED_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED             u32 Sensor_Air_Quality_StatusTampered:1;    /* 0~1 */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED_STORE           STORE_CHAR(Sensor_Air_Quality_StatusTampered,hSensor_Air_Quality_StatusTampered)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED_RESTORE         RESTORE_CHAR(Sensor_Air_Quality_StatusTampered,hSensor_Air_Quality_StatusTampered)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED_RESTORE
#endif

#if CHAR_SENSORAIRQUALITY_STATUSLOWBATTERY_NO_ENABLE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY           u32 Sensor_Air_Quality_StatusLowBattery:1;    /* 0~1 */
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY_STORE         STORE_CHAR(Sensor_Air_Quality_StatusLowBattery,hSensor_Air_Quality_StatusLowBattery)
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY_RESTORE       RESTORE_CHAR(Sensor_Air_Quality_StatusLowBattery,hSensor_Air_Quality_StatusLowBattery)
#else
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY_STORE
#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY_RESTORE
#endif


#define SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T   \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_INDICATOR  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY

#define SENSOR_AIR_QUALITY_STORE_CHAR_TO_FLASH  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_INDICATOR_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED_STORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY_STORE

#define SENSOR_AIR_QUALITY_RESTORE_CHAR_FROM_FLASH  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_INDICATOR_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_OZONE_DENSITY_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_NITROGEN_DIOXIDE_DENSITY_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_SULPHUR_DIOXIDE_DENSITY_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM2_5_DENSITY_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_PM10_DENSITY_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_VOC_DENSITY_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSACTIVE_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSFAULT_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSTAMPERED_RESTORE  \
                    SENSOR_AIR_QUALITY_STORE_CHAR_VALUE_T_SENSOR_AIR_QUALITY_STATUSLOWBATTERY_RESTORE


/* ------------------------------------
    Type Definitions
   ------------------------------------ */


/* ------------------------------------
    Variables Definitions/Declarations
   ------------------------------------ */
EXTERN unsigned char hSensor_Air_Quality_Indicator;
EXTERN unsigned int hSensor_Air_Quality_OzoneDensity;
EXTERN unsigned int hSensor_Air_Quality_NitrogenDioxideDensity;
EXTERN unsigned int hSensor_Air_Quality_SulphurDioxideDensity;
EXTERN unsigned int hSensor_Air_Quality_PM2_5Density;
EXTERN unsigned int hSensor_Air_Quality_PM10Density;
EXTERN unsigned int hSensor_Air_Quality_VOCDensity;
EXTERN unsigned char hSensor_Air_Quality_StatusActive;
EXTERN unsigned char hSensor_Air_Quality_StatusFault;
EXTERN unsigned char hSensor_Air_Quality_StatusTampered;
EXTERN unsigned char hSensor_Air_Quality_StatusLowBattery;

EXTERN unsigned short ccc_hSensorAirQuality_Indicator;
EXTERN unsigned short ccc_hSensorAirQuality_OzoneDensity;
EXTERN unsigned short ccc_hSensorAirQuality_NitrogenDioxideDensity;
EXTERN unsigned short ccc_hSensorAirQuality_SulphurDioxideDensity;
EXTERN unsigned short ccc_hSensorAirQuality_PM2_5Density;
EXTERN unsigned short ccc_hSensorAirQuality_PM10Density;
EXTERN unsigned short ccc_hSensorAirQuality_VOCDensity;
EXTERN unsigned short ccc_hSensorAirQuality_StatusActive;
EXTERN unsigned short ccc_hSensorAirQuality_StatusFault;
EXTERN unsigned short ccc_hSensorAirQuality_StatusTampered;
EXTERN unsigned short ccc_hSensorAirQuality_StatusLowBattery;

#if SENSORAIRQUALITY_INDICATOR_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_INDICATOR ((u8*)&bc_para_hSensorAirQuality_Indicator)
    EXTERN unsigned char bc_para_hSensorAirQuality_Indicator;
#else
    #define BC_PARA_SENSORAIRQUALITY_INDICATOR 0
#endif

#if SENSORAIRQUALITY_OZONE_DENSITY_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_OZONE_DENSITY ((u8*)&bc_para_hSensorAirQuality_OzoneDensity)
    EXTERN unsigned char bc_para_hSensorAirQuality_OzoneDensity;
#else
    #define BC_PARA_SENSORAIRQUALITY_OZONE_DENSITY 0
#endif

#if SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY ((u8*)&bc_para_hSensorAirQuality_NitrogenDioxideDensity)
    EXTERN unsigned char bc_para_hSensorAirQuality_NitrogenDioxideDensity;
#else
    #define BC_PARA_SENSORAIRQUALITY_NITROGEN_DIOXIDE_DENSITY 0
#endif

#if SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY ((u8*)&bc_para_hSensorAirQuality_SulphurDioxideDensity)
    EXTERN unsigned char bc_para_hSensorAirQuality_SulphurDioxideDensity;
#else
    #define BC_PARA_SENSORAIRQUALITY_SULPHUR_DIOXIDE_DENSITY 0
#endif

#if SENSORAIRQUALITY_PM2_5_DENSITY_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_PM2_5_DENSITY ((u8*)&bc_para_hSensorAirQuality_PM2_5Density)
    EXTERN unsigned char bc_para_hSensorAirQuality_PM2_5Density;
#else
    #define BC_PARA_SENSORAIRQUALITY_PM2_5_DENSITY 0
#endif

#if SENSORAIRQUALITY_PM10_DENSITY_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_PM10_DENSITY ((u8*)&bc_para_hSensorAirQuality_PM10Density)
    EXTERN unsigned char bc_para_hSensorAirQuality_PM10Density;
#else
    #define BC_PARA_SENSORAIRQUALITY_PM10_DENSITY 0
#endif

#if SENSORAIRQUALITY_VOC_DENSITY_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_VOC_DENSITY ((u8*)&bc_para_hSensorAirQuality_VOCDensity)
    EXTERN unsigned char bc_para_hSensorAirQuality_VOCDensity;
#else
    #define BC_PARA_SENSORAIRQUALITY_VOC_DENSITY 0
#endif

#if SENSORAIRQUALITY_STATUSACTIVE_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_STATUSACTIVE ((u8*)&bc_para_hSensorAirQuality_StatusActive)
    EXTERN unsigned char bc_para_hSensorAirQuality_StatusActive;
#else
    #define BC_PARA_SENSORAIRQUALITY_STATUSACTIVE 0
#endif

#if SENSORAIRQUALITY_STATUSFAULT_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_STATUSFAULT ((u8*)&bc_para_hSensorAirQuality_StatusFault)
    EXTERN unsigned char bc_para_hSensorAirQuality_StatusFault;
#else
    #define BC_PARA_SENSORAIRQUALITY_STATUSFAULT 0
#endif

#if SENSORAIRQUALITY_STATUSTAMPERED_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_STATUSTAMPERED ((u8*)&bc_para_hSensorAirQuality_StatusTampered)
    EXTERN unsigned char bc_para_hSensorAirQuality_StatusTampered;
#else
    #define BC_PARA_SENSORAIRQUALITY_STATUSTAMPERED 0
#endif

#if SENSORAIRQUALITY_STATUSLOWBATTERY_BRC_ENABLE
    #define BC_PARA_SENSORAIRQUALITY_STATUSLOWBATTERY ((u8*)&bc_para_hSensorAirQuality_StatusLowBattery)
    EXTERN unsigned char bc_para_hSensorAirQuality_StatusLowBattery;
#else
    #define BC_PARA_SENSORAIRQUALITY_STATUSLOWBATTERY 0
#endif

#if SENSOR_AIR_QUALITY_LINKED_SERVICES_ENABLE
	#define SENSOR_AIR_QUALITY_LINKED_SVCS			hSensorAirQuality_linked_svcs
	#define SENSOR_AIR_QUALITY_LINKED_SVCS_LENGTH 	(sizeof(hSensorAirQuality_linked_svcs)/sizeof(size_t)*2)
	EXTERN const u16 * hSensorAirQuality_linked_svcs[];
#else
	#define SENSOR_AIR_QUALITY_LINKED_SVCS			0
	#define SENSOR_AIR_QUALITY_LINKED_SVCS_LENGTH 	0
#endif

EXTERN const u8 hSensor_Air_QualityServiceName[25];

EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_Indicator_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_OzoneDensity_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_NitrogenDioxideDensity_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_SulphurDioxideDensity_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_PM2_5Density_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_PM10Density_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_VOCDensity_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_StatusActive_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_StatusFault_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_StatusTampered_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_hSensor_Air_Quality_StatusLowBattery_R_S;


/* ------------------------------------
    Function Prototypes
   ------------------------------------ */
EXTERN int hSensor_Air_Quality_IndicatorReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_OzoneDensityReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_NitrogenDioxideDensityReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_SulphurDioxideDensityReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_PM2_5DensityReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_PM10DensityReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_VOCDensityReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_StatusActiveReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_StatusFaultReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_StatusTamperedReadCallback(void *pp);
EXTERN int hSensor_Air_Quality_StatusLowBatteryReadCallback(void *pp);

EXTERN int ccc_hSensorAirQuality_IndicatorWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_OzoneDensityWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_NitrogenDioxideDensityWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_SulphurDioxideDensityWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_PM2_5DensityWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_PM10DensityWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_VOCDensityWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_StatusActiveWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_StatusFaultWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_StatusTamperedWriteCB(void *pp);
EXTERN int ccc_hSensorAirQuality_StatusLowBatteryWriteCB(void *pp);


#endif /* _HK_SENSOR_AIR_QUALITY_SERVICE_H_ */

/* %% End Of File %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
