/********************************************************************************************************
 * @file     hk_Valve2Service.h
 *
 * @brief    for TLSR chips
 *
 * @author	 telink
 * @date     Sep. 30, 2010
 *
 * @par      Copyright (c) 2016, Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *           
 *			 The information contained herein is confidential and proprietary property of Telink 
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms 
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai) 
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in. 
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this 
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided. 
 *           
 *******************************************************************************************************/
#ifndef _HK_VALVE2_SERVICE_H_
#define _HK_VALVE2_SERVICE_H_

#include "homekit_src/homekit_inc.h"

/* ------------------------------------
    Header Files
   ------------------------------------ */


/* ------------------------------------
    Macro Definitions
   ------------------------------------ */
#undef EXTERN

#ifdef _HK_VALVE2_SERVICE_C_
    #define EXTERN
#else
    #define EXTERN  extern
#endif

#define CHAR_VALVE2_SVC_SIGN_ENABLE      1
#if CHAR_VALVE2_SVC_SIGN_ENABLE
    #define VALVE2_AS_PRIMARY_SERVICE    	0//1
    #define VALVE2_IS_HIDDEN_SERVICE     	0
    #define VALVE2_LINKED_SERVICES_ENABLE	0
    EXTERN const hap_characteristic_desc_t hap_desc_char_valve2_A5_R_S;
    EXTERN const hap_service_desc_t hap_desc_service_valve2_A5_R_S;
    EXTERN unsigned char VAR_VALVE2_UNKOWN;
#else
    #define VALVE2_AS_PRIMARY_SERVICE    	0
    #define VALVE2_IS_HIDDEN_SERVICE     	0
    #define VALVE2_LINKED_SERVICES_ENABLE	0
#endif

#define VALVE2_ISCONFIGURED_SUPPORT_PAIRED_WRITE		1	//enable default because of Home app(IOS12.4) support it.

#define CHAR_VALVE2_SETDURATION_ENABLE				1
#define CHAR_VALVE2_REMAININGDURATION_ENABLE		1
#define CHAR_VALVE2_ISCONFIGURED_ENABLE				1
#define CHAR_VALVE2_SERVICELABELINDEX_ENABLE   		1
#define CHAR_VALVE2_STATUSFAULT_ENABLE				0


#define VALVE2_ACTIVE_IND_ENABLE					1
#define VALVE2_INUSE_IND_ENABLE						1
#define VALVE2_VALVETYPE_IND_ENABLE					1

#define VALVE2_SETDURATION_IND_ENABLE				1
#define VALVE2_REMAININGDURATION_IND_ENABLE			1
#define VALVE2_ISCONFIGURED_IND_ENABLE				1
#define VALVE2_STATUSFAULT_IND_ENABLE				0


#define VALVE2_ACTIVE_BRC_ENABLE					1
#define VALVE2_INUSE_BRC_ENABLE						1
#define VALVE2_VALVETYPE_BRC_ENABLE					1

#define VALVE2_SETDURATION_BRC_ENABLE				1
#define VALVE2_REMAININGDURATION_BRC_ENABLE			1
#define VALVE2_ISCONFIGURED_BRC_ENABLE				1
#define VALVE2_STATUSFAULT_BRC_ENABLE				0


#define VALVE2_ACTIVE_NO      3
#if VALVE2_ACTIVE_IND_ENABLE
    #define VALVE2_ACTIVE_IND_DESC \
        {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hValve2Active), ccc_Valve2ActiveWriteCB, 0},
    #define VALVE2_ACTIVE_IND_NO  1
#else
    #define VALVE2_ACTIVE_IND_DESC
    #define VALVE2_ACTIVE_IND_NO  0
#endif

#define VALVE2_INUSE_NO      3
#if VALVE2_INUSE_IND_ENABLE
    #define VALVE2_INUSE_IND_DESC \
        {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hValve2InUse), ccc_Valve2InUseWriteCB, 0},
    #define VALVE2_INUSE_IND_NO  1
#else
    #define VALVE2_INUSE_IND_DESC
    #define VALVE2_INUSE_IND_NO  0
#endif

#define VALVE2_VALVETYPE_NO      3
#if VALVE2_VALVETYPE_IND_ENABLE
    #define VALVE2_VALVETYPE_IND_DESC \
        {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hValve2ValveType), ccc_Valve2ValveTypeWriteCB, 0},
    #define VALVE2_VALVETYPE_IND_NO  1
#else
    #define VALVE2_VALVETYPE_IND_DESC
    #define VALVE2_VALVETYPE_IND_NO  0
#endif


#if CHAR_VALVE2_SETDURATION_ENABLE
    #define VALVE2_SETDURATION_NO 3
    #define CHAR_VALVE2_SETDURATION_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_SETDURATION_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof (hValve2SetDuration), 0, (u8*)(&charSetDurationUUID), (u8*)&hValve2SetDuration, Valve2SetDurationWriteCallback, Valve2SetDurationReadCallback},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 5), 0, 0}, \
            VALVE2_SETDURATION_IND_DESC

    #if VALVE2_SETDURATION_IND_ENABLE
        #define VALVE2_SETDURATION_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hValve2SetDuration), ccc_Valve2SetDurationWriteCB, 0},
        #define VALVE2_SETDURATION_IND_NO  1
    #else
        #define VALVE2_SETDURATION_IND_DESC
        #define VALVE2_SETDURATION_IND_NO  0
    #endif
#else
    #define VALVE2_SETDURATION_NO 0
    #define CHAR_VALVE2_SETDURATION_ATT_TABLE
    #define VALVE2_SETDURATION_IND_NO  0
#endif

#if CHAR_VALVE2_REMAININGDURATION_ENABLE
    #define VALVE2_REMAININGDURATION_NO 3
    #define CHAR_VALVE2_REMAININGDURATION_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_REMAININGDURATION_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof (hValve2RemainingDuration), 0, (u8*)(&charRemainingDurationUUID), (u8*)&hValve2RemainingDuration, 0, Valve2RemainingDurationReadCallback},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 6), 0, 0}, \
            VALVE2_REMAININGDURATION_IND_DESC

    #if VALVE2_REMAININGDURATION_IND_ENABLE
        #define VALVE2_REMAININGDURATION_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hValve2RemainingDuration), ccc_Valve2RemainingDurationWriteCB, 0},
        #define VALVE2_REMAININGDURATION_IND_NO  1
    #else
        #define VALVE2_REMAININGDURATION_IND_DESC
        #define VALVE2_REMAININGDURATION_IND_NO  0
    #endif
#else
    #define VALVE2_REMAININGDURATION_NO 0
    #define CHAR_VALVE2_REMAININGDURATION_ATT_TABLE
    #define VALVE2_REMAININGDURATION_IND_NO  0
#endif

#if CHAR_VALVE2_ISCONFIGURED_ENABLE
    #define VALVE2_ISCONFIGURED_NO 3
    #define CHAR_VALVE2_ISCONFIGURED_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_ISCONFIGURED_R_S, 0},  \
        VALVE2_ISCONFIGURED_VALUE_DESC \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 7), 0, 0}, \
            VALVE2_ISCONFIGURED_IND_DESC

    #if VALVE2_ISCONFIGURED_SUPPORT_PAIRED_WRITE
        #define VALVE2_ISCONFIGURED_VALUE_DESC \
            {0,ATT_PERMISSIONS_RDWR,16, sizeof (hValve2IsConfigured), 0, (u8*)(&charIsConfiguredUUID), (u8*)&hValve2IsConfigured, Valve2IsConfiguredWriteCallback, Valve2IsConfiguredReadCallback},
    #else
        #define VALVE2_ISCONFIGURED_VALUE_DESC \
            {0,ATT_PERMISSIONS_RDWR,16, sizeof (hValve2IsConfigured), 0, (u8*)(&charIsConfiguredUUID), (u8*)&hValve2IsConfigured, 0, Valve2IsConfiguredReadCallback},
    #endif

    #if VALVE2_ISCONFIGURED_IND_ENABLE
        #define VALVE2_ISCONFIGURED_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hValve2IsConfigured), ccc_Valve2IsConfiguredWriteCB, 0},
        #define VALVE2_ISCONFIGURED_IND_NO  1
    #else
        #define VALVE2_ISCONFIGURED_IND_DESC
        #define VALVE2_ISCONFIGURED_IND_NO  0
    #endif
#else
    #define VALVE2_ISCONFIGURED_NO 0
    #define CHAR_VALVE2_ISCONFIGURED_ATT_TABLE
    #define VALVE2_ISCONFIGURED_IND_NO  0
#endif

#if CHAR_VALVE2_SERVICELABELINDEX_ENABLE
    #define VALVE2_SERVICELABELINDEX_NO 3
    #define CHAR_VALVE2_SERVICELABELINDEX_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_SERVICELABELINDEX_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hValve2ServiceLabelIndex),0, (u8*)(charServiceLabelIndexUUID), (u8*)&hValve2ServiceLabelIndex, 0, Valve2ServiceLabelIndexReadCallback},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 8), 0, 0},
#else
    #define VALVE2_SERVICELABELINDEX_NO 0
    #define CHAR_VALVE2_SERVICELABELINDEX_ATT_TABLE
#endif


#if CHAR_VALVE2_STATUSFAULT_ENABLE
    #define VALVE2_STATUSFAULT_NO 3
    #define CHAR_VALVE2_STATUSFAULT_ATT_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_STATUSFAULT_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof (hValve2StatusFault), 0, (u8*)(&charStatusFaultUUID), (u8*)&hValve2StatusFault, 0, Valve2StatusFaultReadCallback},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 9), 0, 0}, \
            VALVE2_STATUSFAULT_IND_DESC

    #if VALVE2_STATUSFAULT_IND_ENABLE
        #define VALVE2_STATUSFAULT_IND_DESC \
            {0,ATT_PERMISSIONS_RDWR,2,2,2, (u8*)(&ClientCharConfig_UUID), (u8*)(&ccc_hValve2StatusFault), ccc_Valve2StatusFaultWriteCB, 0},
        #define VALVE2_STATUSFAULT_IND_NO  1
    #else
        #define VALVE2_STATUSFAULT_IND_DESC
        #define VALVE2_STATUSFAULT_IND_NO  0
    #endif
#else
    #define VALVE2_STATUSFAULT_NO 0
    #define CHAR_VALVE2_STATUSFAULT_ATT_TABLE
    #define VALVE2_STATUSFAULT_IND_NO  0
#endif


#if CHAR_VALVE2_SVC_SIGN_ENABLE
    #define VALVE2_SVC_SIGN_NO   3
    #define CHAR_VALVE2_SVC_A5_SIGN_TABLE   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteProp), (att_readwrite_callback_t)&hap_desc_char_valve2_A5_R_S, (att_readwrite_callback_t)&hap_desc_service_valve2_A5_R_S},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof (VAR_VALVE2_UNKOWN),0, (u8*)(HapServiceSignatureCharUUID), (u8*)&VAR_VALVE2_UNKOWN, 0, 0},    \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 10), 0, 0},
#else
    #define VALVE2_SVC_SIGN_NO   0
    #define CHAR_VALVE2_SVC_A5_SIGN_TABLE
#endif


#define VALVE2_NO_DELTA   VALVE2_ACTIVE_IND_NO \
                        + VALVE2_INUSE_IND_NO \
                        + VALVE2_VALVETYPE_IND_NO \
                        + VALVE2_SETDURATION_IND_NO \
                        + VALVE2_REMAININGDURATION_IND_NO \
                        + VALVE2_ISCONFIGURED_IND_NO \
                        + VALVE2_STATUSFAULT_IND_NO


#define VALVE2_NO   15 + VALVE2_SETDURATION_NO \
	                + VALVE2_REMAININGDURATION_NO \
	                + VALVE2_ISCONFIGURED_NO \
	                + VALVE2_SERVICELABELINDEX_NO \
	                + VALVE2_STATUSFAULT_NO \
	                + VALVE2_SVC_SIGN_NO


#define VALVE2_HANDLE_NUM (VALVE2_NO + VALVE2_NO_DELTA)


#define HOMEKIT_VALVE2_SERVICE_ATT_TABLE   \
    {VALVE2_HANDLE_NUM,ATT_PERMISSIONS_READ,2,sizeof(valveServiceUUID),sizeof(valveServiceUUID), (u8*)(&primaryServiceUUID), (u8*)(valveServiceUUID), 0, 0},   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readOnlyProp), 0, 0},   \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(serviceInstanceUUID), (u8*)(insts + VALVE2_INST_NO), 0, 0},   \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteProp), (att_readwrite_callback_t)&hap_desc_char_NAME, 0},    \
        {0,ATT_PERMISSIONS_RDWR,16, sizeof(hValve2ServiceName), 0, (u8*)(nameUUID), (u8*)(hValve2ServiceName), 0, HAPCommonSetSessionTimeoutReadCB},  \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(&charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 1), 0, 0}, \
		{0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_ACTIVE_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hValve2Active),0, (u8*)(charActiveUUID), (u8*)&hValve2Active, Valve2ActiveWriteCallback, Valve2ActiveReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 2), 0, 0},  \
            VALVE2_ACTIVE_IND_DESC \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_INUSE_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hValve2InUse),0, (u8*)(charInUseUUID), (u8*)&hValve2InUse, 0, Valve2InUseReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 3), 0, 0},  \
            VALVE2_INUSE_IND_DESC \
        {0,ATT_PERMISSIONS_READ,2,1,1, (u8*)(&characterUUID), (u8*)(&readWriteIndicateProp), (att_readwrite_callback_t)&hap_desc_char_VALVE2_VALVETYPE_R_S, 0},  \
        {0,ATT_PERMISSIONS_RDWR,16,sizeof(hValve2ValveType),0, (u8*)(charValveTypeUUID), (u8*)&hValve2ValveType, 0, Valve2ValveTypeReadCallback}, \
            {0,ATT_PERMISSIONS_READ,16,2,2, (u8*)(charInstanceUUID), (u8*)(insts + VALVE2_INST_NO + 4), 0, 0},  \
            VALVE2_VALVETYPE_IND_DESC \
        CHAR_VALVE2_SETDURATION_ATT_TABLE \
        CHAR_VALVE2_REMAININGDURATION_ATT_TABLE \
        CHAR_VALVE2_ISCONFIGURED_ATT_TABLE \
        CHAR_VALVE2_SERVICELABELINDEX_ATT_TABLE \
        CHAR_VALVE2_STATUSFAULT_ATT_TABLE \
        CHAR_VALVE2_SVC_A5_SIGN_TABLE


#define VALVE2_HANDLE_COMMON_NUM     8

#define VALVE2_HANDLE_NUM_ACTIVE					VALVE2_HANDLE_START_NUM +VALVE2_HANDLE_COMMON_NUM
#define VALVE2_HANDLE_NUM_INUSE					VALVE2_HANDLE_NUM_ACTIVE +VALVE2_ACTIVE_NO +VALVE2_ACTIVE_IND_NO
#define VALVE2_HANDLE_NUM_VALVETYPE				VALVE2_HANDLE_NUM_INUSE +VALVE2_INUSE_NO +VALVE2_INUSE_IND_NO
#define VALVE2_HANDLE_NUM_SETDURATION			VALVE2_HANDLE_NUM_VALVETYPE +VALVE2_VALVETYPE_NO +VALVE2_VALVETYPE_IND_NO
#define VALVE2_HANDLE_NUM_REMAININGDURATION		VALVE2_HANDLE_NUM_SETDURATION +VALVE2_SETDURATION_NO +VALVE2_SETDURATION_IND_NO
#define VALVE2_HANDLE_NUM_ISCONFIGURED			VALVE2_HANDLE_NUM_REMAININGDURATION +VALVE2_REMAININGDURATION_NO +VALVE2_REMAININGDURATION_IND_NO
#define VALVE2_HANDLE_NUM_SERVICELABELINDEX		VALVE2_HANDLE_NUM_ISCONFIGURED +VALVE2_ISCONFIGURED_NO +VALVE2_ISCONFIGURED_IND_NO
#define VALVE2_HANDLE_NUM_STATUSFAULT			VALVE2_HANDLE_NUM_SERVICELABELINDEX +VALVE2_SERVICELABELINDEX_NO +0
#define VALVE2_HANDLE_NUM_THE_END


#define VALVE2_STORE_CHAR_VALUE_T_ACTIVE							u32 Valve2Active:1;     /* 0~1 */
#define VALVE2_STORE_CHAR_VALUE_T_ACTIVE_STORE					STORE_CHAR(Valve2Active, hValve2Active)
#define VALVE2_STORE_CHAR_VALUE_T_ACTIVE_RESTORE					RESTORE_CHAR(Valve2Active, hValve2Active)

#define VALVE2_STORE_CHAR_VALUE_T_INUSE							u32 Valve2InUse:1;   /* 0~1 */
#define VALVE2_STORE_CHAR_VALUE_T_INUSE_STORE					STORE_CHAR(Valve2InUse, hValve2InUse)
#define VALVE2_STORE_CHAR_VALUE_T_INUSE_RESTORE					RESTORE_CHAR(Valve2InUse, hValve2InUse)

#define VALVE2_STORE_CHAR_VALUE_T_VALVETYPE						u32 Valve2ValveType:2;    /* 0~3 */
#define VALVE2_STORE_CHAR_VALUE_T_VALVETYPE_STORE				STORE_CHAR(Valve2ValveType, hValve2ValveType)
#define VALVE2_STORE_CHAR_VALUE_T_VALVETYPE_RESTORE				RESTORE_CHAR(Valve2ValveType, hValve2ValveType)

#if CHAR_VALVE2_SETDURATION_ENABLE
#define VALVE2_STORE_CHAR_VALUE_T_SETDURATION					u32 Valve2SetDuration:12;   /* 0~3600 */
#define VALVE2_STORE_CHAR_VALUE_T_SETDURATION_STORE       		STORE_CHAR(Valve2SetDuration, hValve2SetDuration)
#define VALVE2_STORE_CHAR_VALUE_T_SETDURATION_RESTORE			RESTORE_CHAR(Valve2SetDuration, hValve2SetDuration)
#else
#define VALVE2_STORE_CHAR_VALUE_T_SETDURATION
#define VALVE2_STORE_CHAR_VALUE_T_SETDURATION_STORE
#define VALVE2_STORE_CHAR_VALUE_T_SETDURATION_RESTORE
#endif

#if CHAR_VALVE2_REMAININGDURATION_ENABLE
#define VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION				u32 Valve2RemainingDuration:12;   /* 0~3600 */
#define VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION_STORE       	STORE_CHAR(Valve2RemainingDuration, hValve2RemainingDuration)
#define VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION_RESTORE		RESTORE_CHAR(Valve2RemainingDuration, hValve2RemainingDuration)
#else
#define VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION
#define VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION_STORE
#define VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION_RESTORE
#endif

#if CHAR_VALVE2_ISCONFIGURED_ENABLE
#define VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED					u32 Valve2IsConfigured:1;   /* 0~1 */
#define VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED_STORE       		STORE_CHAR(Valve2IsConfigured, hValve2IsConfigured)
#define VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED_RESTORE			RESTORE_CHAR(Valve2IsConfigured, hValve2IsConfigured)
#else
#define VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED
#define VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED_STORE
#define VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED_RESTORE
#endif

#if CHAR_VALVE2_SERVICELABELINDEX_ENABLE
#define VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX                          u32 Valve2ServiceLabelIndex:8; /* Min Value is 1 */
#define VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX_STORE                        STORE_CHAR(Valve2ServiceLabelIndex,hValve2ServiceLabelIndex)
#define VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX_RESTORE                      RESTORE_CHAR(Valve2ServiceLabelIndex,hValve2ServiceLabelIndex)
#else
#define VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX
#define VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX_STORE
#define VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX_RESTORE
#endif

#if CHAR_VALVE2_STATUSFAULT_ENABLE
#define VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT					u32 Valve2StatusFault:1;   /* 0~1 */
#define VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT_STORE				STORE_CHAR(Valve2StatusFault, hValve2StatusFault)
#define VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT_RESTORE			RESTORE_CHAR(Valve2StatusFault, hValve2StatusFault)
#else
#define VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT
#define VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT_STORE
#define VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT_RESTORE
#endif


#define VALVE2_STORE_CHAR_VALUE_T            \
        VALVE2_STORE_CHAR_VALUE_T_ACTIVE \
        VALVE2_STORE_CHAR_VALUE_T_INUSE \
        VALVE2_STORE_CHAR_VALUE_T_VALVETYPE \
        VALVE2_STORE_CHAR_VALUE_T_SETDURATION \
        VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION \
        VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED \
        VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX \
        VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT

#define VALVE2_STORE_CHAR_TO_FLASH            \
        VALVE2_STORE_CHAR_VALUE_T_ACTIVE_STORE \
        VALVE2_STORE_CHAR_VALUE_T_INUSE_STORE \
        VALVE2_STORE_CHAR_VALUE_T_VALVETYPE_STORE \
        VALVE2_STORE_CHAR_VALUE_T_SETDURATION_STORE \
        VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION_STORE \
        VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED_STORE \
        VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX_STORE \
        VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT_STORE

#define VALVE2_RESTORE_CHAR_FROM_FLASH            \
        VALVE2_STORE_CHAR_VALUE_T_ACTIVE_RESTORE \
        VALVE2_STORE_CHAR_VALUE_T_INUSE_RESTORE \
        VALVE2_STORE_CHAR_VALUE_T_VALVETYPE_RESTORE \
        VALVE2_STORE_CHAR_VALUE_T_SETDURATION_RESTORE \
        VALVE2_STORE_CHAR_VALUE_T_REMAININGDURATION_RESTORE \
        VALVE2_STORE_CHAR_VALUE_T_ISCONFIGURED_RESTORE \
        VALVE2_STORE_CHAR_VALUE_T_SERVICELABELINDEX_RESTORE \
        VALVE2_STORE_CHAR_VALUE_T_STATUSFAULT_RESTORE


/* ------------------------------------
    Type Definitions
   ------------------------------------ */


/* ------------------------------------
    Variables Definitions/Declarations
   ------------------------------------ */
EXTERN unsigned char hValve2Active;
EXTERN unsigned char hValve2InUse;
EXTERN unsigned char hValve2ValveType;
EXTERN unsigned int hValve2SetDuration;
EXTERN unsigned int hValve2RemainingDuration;
EXTERN unsigned char hValve2IsConfigured;
EXTERN unsigned char hValve2ServiceLabelIndex;
EXTERN unsigned char hValve2StatusFault;

	
EXTERN unsigned short ccc_hValve2Active;
EXTERN unsigned short ccc_hValve2InUse;
EXTERN unsigned short ccc_hValve2ValveType;
EXTERN unsigned short ccc_hValve2SetDuration;
EXTERN unsigned short ccc_hValve2RemainingDuration;
EXTERN unsigned short ccc_hValve2IsConfigured;
EXTERN unsigned short ccc_hValve2StatusFault;


#if VALVE2_ACTIVE_BRC_ENABLE
    #define BC_PARA_VALVE2_ACTIVE ((u8*)&bc_para_hValve2Active)
    EXTERN unsigned char bc_para_hValve2Active;
#else
    #define BC_PARA_VALVE2_ACTIVE 0
#endif

#if VALVE2_INUSE_BRC_ENABLE
    #define BC_PARA_VALVE2_INUSE ((u8*)&bc_para_hValve2InUse)
    EXTERN unsigned char bc_para_hValve2InUse;
#else
    #define BC_PARA_VALVE2_INUSE 0
#endif

#if VALVE2_VALVETYPE_BRC_ENABLE
    #define BC_PARA_VALVE2_VALVETYPE ((u8*)&bc_para_hValve2ValveType)
    EXTERN unsigned char bc_para_hValve2ValveType;
#else
    #define BC_PARA_VALVE2_VALVETYPE 0
#endif

#if VALVE2_SETDURATION_BRC_ENABLE
    #define BC_PARA_VALVE2_SETDURATION ((u8*)&bc_para_hValve2SetDuration)
    EXTERN unsigned char bc_para_hValve2SetDuration;
#else
    #define BC_PARA_VALVE2_SETDURATION 0
#endif

#if VALVE2_REMAININGDURATION_BRC_ENABLE
    #define BC_PARA_VALVE2_REMAININGDURATION ((u8*)&bc_para_hValve2RemainingDuration)
    EXTERN unsigned char bc_para_hValve2RemainingDuration;
#else
    #define BC_PARA_VALVE2_REMAININGDURATION 0
#endif

#if VALVE2_ISCONFIGURED_BRC_ENABLE
    #define BC_PARA_VALVE2_ISCONFIGURED ((u8*)&bc_para_hValve2IsConfigured)
    EXTERN unsigned char bc_para_hValve2IsConfigured;
#else
    #define BC_PARA_VALVE2_ISCONFIGURED 0
#endif

#if VALVE2_STATUSFAULT_BRC_ENABLE
    #define BC_PARA_VALVE2_STATUSFAULT ((u8*)&bc_para_hValve2StatusFault)
    EXTERN unsigned char bc_para_hValve2StatusFault;
#else
    #define BC_PARA_VALVE2_STATUSFAULT 0
#endif

#if VALVE2_LINKED_SERVICES_ENABLE
	#define VALVE2_LINKED_SVCS			hValve2_linked_svcs
	#define VALVE2_LINKED_SVCS_LENGTH 	(sizeof(hValve2_linked_svcs)/sizeof(size_t)*2)
	EXTERN const u16 * hValve2_linked_svcs[];
#else
	#define VALVE2_LINKED_SVCS			0
	#define VALVE2_LINKED_SVCS_LENGTH 	0
#endif

EXTERN const u8 hValve2ServiceName[13];


EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_ACTIVE_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_INUSE_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_VALVETYPE_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_SETDURATION_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_REMAININGDURATION_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_ISCONFIGURED_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_SERVICELABELINDEX_R_S;
EXTERN const hap_characteristic_desc_t hap_desc_char_VALVE2_STATUSFAULT_R_S;


/* ------------------------------------
    Function Prototypes
   ------------------------------------ */
EXTERN int Valve2ActiveReadCallback(void *pp);
EXTERN int Valve2ActiveWriteCallback(void *pp);
EXTERN int Valve2InUseReadCallback(void *pp);
EXTERN int Valve2ValveTypeReadCallback(void *pp);
EXTERN int Valve2SetDurationReadCallback(void *pp);
EXTERN int Valve2SetDurationWriteCallback(void *pp);
EXTERN int Valve2RemainingDurationReadCallback(void *pp);
EXTERN int Valve2IsConfiguredReadCallback(void *pp);
EXTERN int Valve2IsConfiguredWriteCallback(void *pp);
EXTERN int Valve2ServiceLabelIndexReadCallback(void *pp);
EXTERN int Valve2StatusFaultReadCallback(void *pp);


EXTERN int ccc_Valve2ActiveWriteCB(void *pp);
EXTERN int ccc_Valve2InUseWriteCB(void *pp);
EXTERN int ccc_Valve2ValveTypeWriteCB(void *pp);
EXTERN int ccc_Valve2SetDurationWriteCB(void *pp);
EXTERN int ccc_Valve2RemainingDurationWriteCB(void *pp);
EXTERN int ccc_Valve2IsConfiguredWriteCB(void *pp);
EXTERN int ccc_Valve2StatusFaultWriteCB(void *pp);

#endif /* _HK_VALVE2_SERVICE_H_ */

/* %% End Of File %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
