/*
 * ota_vendor_cmd.c
 *
 *  Created on: 2019-2-15
 *      Author: Administrator
 */

/******************************************************
 * 				ota vendor cmd
 *****************************************************/

#include "ota_vendor_cmd.h"
#include "../../../homekit_src/hk_ble_ll_ota.h"
#include "../common.h"
#include "../hk_LightBulbService.h"


extern void cfg_led_event(u32 e);
extern void light_enable (int en);


extern hkble_ota_startCb_t		hkble_otaStartCb;
extern int hkble_ota_adr_index;
extern u8 hkble_ota_data_check;

#if SOFTWARE_AUTHENTICATION_ENABLE
static u16 token_wr_len = 0;
static u16 token_wr_offset = 0;
short token_wr_index = -1;
static u32 token_wr_timeout = 0;
static u16 token_rd_len = 0;
static u16 token_rd_offset = 0;
short token_rd_index = -1;
static u32 token_rd_timeout = 0;
#endif

_attribute_data_retention_	short rssi = 0;

/************************************************************************
*						   		Proc RSSI
 ***********************************************************************/
unsigned char Rf_rssi_filter(unsigned char tmp_rssi)
{
	#define RSSI_NUM 5

	static unsigned char store_full_flag = 0,filter_first_flag = 0;
	static unsigned char store_rssi_value[RSSI_NUM] = {0};
	static unsigned char sort_rssi_value[RSSI_NUM] = {0};

	static unsigned int rssi_filter = 0,mid_cal_data = 0;
	static unsigned char rssi_index = 0;

	if((rssi_index < RSSI_NUM-1)&& (!store_full_flag)){
		store_rssi_value[rssi_index] = tmp_rssi;
		mid_cal_data = tmp_rssi;
	}
	else{
		store_full_flag = 1;						//receive 5 packets' flag
		store_rssi_value[rssi_index] = tmp_rssi;
		unsigned char copy_index = 0;

		for(copy_index = 0;copy_index<RSSI_NUM;copy_index++){
			sort_rssi_value[copy_index] = store_rssi_value[copy_index];
		}
		unsigned char i = 0,j = 0;
		unsigned char tmp_sort = 0;
		for(i=0;i<RSSI_NUM-1;i++){
			for(j=0;j<RSSI_NUM-1-i;j++){
				if(sort_rssi_value[j] > sort_rssi_value[j+1]){
					tmp_sort = sort_rssi_value[j];
					sort_rssi_value[j] = sort_rssi_value[j+1];
					sort_rssi_value[j+1] = tmp_sort;
				}
			}
		}
		mid_cal_data = sort_rssi_value[RSSI_NUM>>1];
	}

	if(!filter_first_flag){ 						///filter_first_flag == 0
		filter_first_flag = 1;
		rssi_filter = mid_cal_data;
	}
	else{											//filter_first_flag ==	1
													//+2 to rounding  +2/4
		rssi_filter = (3*rssi_filter + 1*mid_cal_data + 2)>>2;
	}

	rssi_index++;
	rssi_index %= RSSI_NUM; 						//from the header restore data
	return rssi_filter;
}

void Rf_rssi_proc(void)
{

	extern u8 * blt_get_rx_buffer (int write);
	u8 * prx = blt_get_rx_buffer (1);
	u8 rssi_temp = prx[4];

	rssi = Rf_rssi_filter(rssi_temp) - 110;//filter RSSI

	return;
}

short app_get_rssi(void)
{
	return rssi;
}

#if SOFTWARE_AUTHENTICATION_ENABLE
void CustVendorCmd_SoftAuth_wr_reset(void)
{
	token_wr_timeout = 0;
	if(token_wr_len && token_wr_offset && (token_wr_index > -1)){
		flash_erase_sector((unsigned long)flash_adr_layout.flash_adr_sw_token);
	}
	token_wr_len = 0;
	token_wr_offset = 0;
	token_wr_index = -1;
}

void CustVendorCmd_SoftAuth_rd_reset(void)
{
	token_rd_timeout = 0;
	token_rd_len = 0;
	token_rd_offset = 0;
	token_rd_index = -1;
}

void CustVendorCmd_SoftAuth_timeout_check(void)
{
	if(token_wr_timeout && clock_time_exceed(token_wr_timeout, CMD_SOFTAUTH_TIMEOUT_DUR)){
		CustVendorCmd_SoftAuth_wr_reset();
	}
	
	if(token_rd_timeout && clock_time_exceed(token_rd_timeout, CMD_SOFTAUTH_TIMEOUT_DUR)){
		CustVendorCmd_SoftAuth_rd_reset();
	}
}
#endif


void CustVendorCmdFunctions(void *p)
{
    rf_packet_att_data_t *req = (rf_packet_att_data_t*)p;


    u16 CmdNo =  req->dat[0] | (req->dat[1]<<8);
    u8 *parameter = &(req->dat[2]);

    int nDataLen = req->l2cap - 5;

    memset(otabuffer, 0, 20);

    if(CmdNo >= 0xFF00){
        // for OTA cust. flow
        if(CmdNo == HKBLE_CMD_OTA_FW_VERSION){
            //to be add
            //log_event(TR_T_ota_version);
        }
        else if(CmdNo == HKBLE_CMD_OTA_START){

			#if (FLASH_ADR_TYPE == FLASH_ADR_TYPE_DUAL_MODE)
			ota_auth_enable = true;
			extern u8	dualmode_ota_key_user[8];
			auth_err_flag = hkble_dualmode_ota_auth_verify(dualmode_ota_key_user, (u8 *)&req->dat[2]);
			if(!auth_err_flag)
			#endif
			{
				extern hkble_ota_service_t hkble_blcOta;
				extern hkble_ota_service_t hkble_hk_blcOta;
				hkble_blcOta.ota_start_flag = 1;   //set flag
				hkble_hk_blcOta.ota_start_flag = 1;   //set flag
	            if(hkble_otaStartCb){
	                hkble_otaStartCb();
	            }

				#if (HKBLE_OTA_FW_CHECK_EN)
				hkble_blcOta.fw_crc_last_index = 0xFFFF;
				hkble_hk_blcOta.fw_crc_last_index = 0xFFFF;
				hkble_ota_data_check = HKBLE_OTA_DATA_START;
				#endif
			}
			if(ota_auth_enable) memcpy(otabuffer, &auth_err_flag, 1);
        }
        else if(CmdNo == HKBLE_CMD_OTA_END){
			u8 err_flg = HKBLE_OTA_SUCCESS;
			u16 adrIndex_max	   = req->dat[2] | (req->dat[3]<<8);
			u16 adrIndex_max_check = req->dat[4] | (req->dat[5]<<8);

			//if no index_max check, set ota success directly, otherwise we check if any index_max match
			if( req->l2cap == 9 && (adrIndex_max ^ adrIndex_max_check) == 0xffff){  //index_max valid, we can check
				if(adrIndex_max != hkble_ota_adr_index){  //last one or more packets missed
					err_flg = HKBLE_OTA_DATA_UNCOMPLETE;
				}
			}

			if(!err_flg){
				#if (!HKBLE_OTA_DATA_VERIFY_AFTER_SAVE_EN)
				hkble_ota_set_flag ();

				extern void dev_mac_addr_update(void);
				dev_mac_addr_update();
            	//R10 clear broadcast event param.
            	//blt_clean_broadcast_param();
            	bls_ll_terminateConnection(0x13);
				rf_led_ota_ok();
				start_reboot();
				hkble_ota_data_check = HKBLE_OTA_DATA_NONE;
				#else
		        //extern void hkble_ota_verify_data_from_flash(void);
				//hkble_ota_verify_data_from_flash();
				hkble_ota_data_check = HKBLE_OTA_DATA_END;
				#endif
			}else{
				if (hkble_ota_adr_index >= 0)
				{
					for(int i=0; i<=hkble_ota_adr_index; i+=256)
					{
						// 4K/16 = 256
						#if(__TL_LIB_8258__ || (MCU_CORE_TYPE && MCU_CORE_TYPE == MCU_CORE_8258))
						extern u32 ota_program_offset;
						flash_erase_sector(ota_program_offset + (i<<4));
						#else
						flash_erase_sector(NEW_FW_ADR + (i<<4));
						#endif
					}
				}
				bls_ll_terminateConnection(0x13);
				rf_led_ota_error();
				start_reboot();
			}

        }
    }else if(CmdNo >= 0xFE00)
    {
        //just for store and restore mac addr, serial num, setup code.
        enum{
            CMD_SET_MAC_ADDR            = (0xFE00),
            CMD_GET_MAC_ADDR            = (0xFE01),
            CMD_SET_SERIAL_NUM          = (0xFE02),
            CMD_GET_SERIAL_NUM          = (0xFE03),
            CMD_SET_SETUP_CODE          = (0xFE04),
            CMD_GET_SETUP_CODE          = (0xFE05),
            CMD_SET_SETUP_ID            = (0xFE06),
            CMD_GET_SETUP_ID            = (0xFE07),
			CMD_GET_MFI_I2C_ID			= (0xFE08),
			CMD_TEST_LED				= (0xFE09),
			CMD_GET_DEVICE_ID			= (0xFE0A),
			CMD_GET_HASH_ID				= (0xFE0B),
			CMD_GET_RSSI				= (0xFE0C),
			CMD_SET_SW_AUTH_UUID		= (0xFE0D),
			CMD_GET_SW_AUTH_UUID		= (0xFE0E),
			CMD_SET_SW_AUTH_TOKEN		= (0xFE0F),
			CMD_GET_SW_AUTH_TOKEN		= (0xFE10),
			CMD_SET_AMAZON_INFO			= (0xFE11),		//for mesh of dual mode.
			CMD_GET_AMAZON_INFO			= (0xFE12),		//for mesh of dual mode.

        };

        enum{
            CMD_SET_CUSTOM_VALUE_SUCCESS    = (0x0),
            CMD_SET_CUSTOM_VALUE_ERROR      = (0x01),
            CMD_SET_CUSTOM_VALUE_REJECT     = (0x02),
            CMD_SET_CUSTOM_VALUE_UNCOMPLETED= (0x03),
        };

        u8 data[12];

        memcpy(data, &req->dat[0], 2);

        switch(CmdNo)
        {
            #if MAC_ADDR_RANDOM_ENABLE
            case CMD_SET_MAC_ADDR:
                if(nDataLen == 6)
                {
                    u32 *p_mac = (u32 *) flash_adr_layout.flash_adr_mac;

                    if (*p_mac != 0xffffffff)
                    {
                        flash_erase_sector(flash_adr_layout.flash_adr_mac);
                    }

                    flash_write_page(flash_adr_layout.flash_adr_mac, 6, parameter);
                    memcpy(tbl_mac, parameter, 6);

                    data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
                    memcpy(otabuffer, data, 3);
                }
                break;

            case CMD_GET_MAC_ADDR:
                if(nDataLen == 0)
                {
                    memcpy(data + 2, tbl_mac, 6);
                    memcpy(otabuffer, data, 8);
                }
                break;
            #endif

            #if SERIAL_NUMBER_RANDOM_ENABLE
            case CMD_SET_SERIAL_NUM:
                if(nDataLen == 10)
                {

                    u32 *p_serial_num = (u32 *) flash_adr_layout.flash_adr_serial_number;

                    if (*p_serial_num != 0xffffffff)
                    {
                        flash_erase_sector(flash_adr_layout.flash_adr_serial_number);
                    }

                    flash_write_page(flash_adr_layout.flash_adr_serial_number, sizeof(serialNumber), parameter);

                    memcpy(serialNumber, parameter, sizeof(serialNumber));

                    data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
                    memcpy(otabuffer, data, 3);
                }
                break;

            case CMD_GET_SERIAL_NUM:
                if(nDataLen == 0)
                {
                    memcpy(data+2, serialNumber, sizeof(serialNumber));
                    memcpy(otabuffer, data, (2 + sizeof(serialNumber)));
                }
                break;
            #endif

            #if SETUP_CODE_RANDOM_ENABLE
            case CMD_SET_SETUP_CODE:
                if(nDataLen == 4)
                {
                	#if (FLASH_ADR_TYPE == FLASH_ADR_TYPE_DEFAULT)
					
                    if(SetupCodeWriteCnts < SETUP_CODE_WRITE_CNTS_MAX)
                    {
                        u32 *p_setup_code = (u32 *) flash_adr_layout.flash_adr_setupcode;

                        if (*p_setup_code != 0xffffffff)
                        {
                            flash_erase_sector(flash_adr_layout.flash_adr_setupcode);
                        }

                        SetupCodeWriteCnts++;
                        parameter[4] = SetupCodeWriteCnts;
                        flash_write_page(flash_adr_layout.flash_adr_setupcode, 5, parameter);
                        memcpy((u8 *)&SetupCodeData, parameter, 4);
                        if(SetupCodeReadCnts > 0)
                            flash_subregion_write_val(flash_adr_layout.flash_adr_setupcode_read_cnt, 0, SetupCodeReadCnts, SETUP_CODE_READ_CNTS_MAX);

                        data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;

                        /* execute factory reset.*/
                        irq_disable();
                        factory_reset();

                        irq_disable ();
                        REG_ADDR8(0x6F) = 0x20; // rst all(act as power on reset)
                        while (1);
                    }
                    else
                    {
                        /*exceed the range of times of write setup code*/
                        data[2] = CMD_SET_CUSTOM_VALUE_REJECT;
                    }
					
					#elif (FLASH_ADR_TYPE == FLASH_ADR_TYPE_DUAL_MODE)
					
					u32 *p_setup_code = (u32 *) flash_adr_layout.flash_adr_setupcode;
					
					if (*p_setup_code != 0xffffffff)
					{
						flash_erase_sector(flash_adr_layout.flash_adr_setupcode);
					}
					
					flash_write_page(flash_adr_layout.flash_adr_setupcode, 4, parameter);
					memcpy((u8 *)&SetupCodeData, parameter, 4);
					
					data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
					
					/* execute factory reset.*/
					irq_disable();
					factory_reset();

					irq_disable ();
					REG_ADDR8(0x6F) = 0x20; // rst all(act as power on reset)
					while (1);
					
					#endif
					
                    memcpy(otabuffer, data, 3);
                }
                break;

            case CMD_GET_SETUP_CODE:
                if(nDataLen == 0)
                {
                	#if (FLASH_ADR_TYPE == FLASH_ADR_TYPE_DEFAULT)
					
                    if(SetupCodeReadCnts < SETUP_CODE_READ_CNTS_MAX)
                    {
                        SetupCodeReadCnts++;
                        flash_subregion_write_val(flash_adr_layout.flash_adr_setupcode_read_cnt, 0, SetupCodeReadCnts, SETUP_CODE_READ_CNTS_MAX);
                        memcpy(data + 2, (u8 *)&SetupCodeData, 4);
                        memcpy(otabuffer, data, 6);
                    }
                    else
                    {
                        /*exceed the range of times of read setup code*/
                        data[2] = CMD_SET_CUSTOM_VALUE_REJECT;
                        memcpy(otabuffer, data, 3);
                    }
					
					#elif (FLASH_ADR_TYPE == FLASH_ADR_TYPE_DUAL_MODE)
					
					memcpy(data + 2, (u8 *)&SetupCodeData, 4);
					memcpy(otabuffer, data, 6);
					
					#endif
                }
                break;
            #endif

            #if SETUP_ID_RANDOM_ENABLE
            case CMD_SET_SETUP_ID:
                if(nDataLen == 4)
                {
                    u32 *p_setup_id = (u32 *) flash_adr_layout.flash_adr_setup_id;

                    if (*p_setup_id != 0xffffffff)
                    {
                        flash_erase_sector(flash_adr_layout.flash_adr_setup_id);
                    }

                    flash_write_page(flash_adr_layout.flash_adr_setup_id, 4, parameter);
                    memcpy((u8 *)&SetupIdData, parameter, 4);
                    data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
                    memcpy(otabuffer, data, 3);

                    // apply new setup ID to generate new setup HASH code.
                    dev_hash_deviceid_set();
                    u8 hk_setupHash[4];
                    flash_read_page((u32)(flash_adr_layout.flash_adr_hash_id), 4, hk_setupHash);
                    blt_adv_update_pkt(ADV_PKT_SETUP_HASH, hk_setupHash);
                }
                break;

            case CMD_GET_SETUP_ID:
                if(nDataLen == 0)
                {
                    memcpy(data + 2, (u8 *)&SetupIdData, 4);
                    memcpy(otabuffer, data, 6);
                }
                break;
            #endif

			case CMD_GET_MFI_I2C_ID:
                if(nDataLen == 0)
                {
                	u8 dev_id[4] = {0};
					if(app_verify_mfi_i2c(dev_id))
					{
						data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
						memcpy(data + 3, dev_id, 4);
						memcpy(otabuffer, data, 7);
					}
					else
					{
						data[2] = CMD_SET_CUSTOM_VALUE_ERROR;
						memcpy(otabuffer, data, 3);
					}
				}
				break;

			case CMD_TEST_LED:
                if(nDataLen == 1)
                {
					#define LED_OFF		0
                	#define LED_ON		1
					#define LED_FLASH	2

					if((parameter[0] == LED_OFF) || (parameter[0] == LED_ON))
					{
						light_enable (parameter[0]);
					}
					else if(parameter[0] == LED_FLASH)
					{
						cfg_led_event(LED_EVENT_FLASH_2HZ_5TIMES);
					}
					data[2] = parameter[0];
					data[3] = CMD_SET_CUSTOM_VALUE_SUCCESS;
                    memcpy(otabuffer, data, 4);
                }
				break;

			case CMD_GET_DEVICE_ID:
                if(nDataLen == 0)
                {
					u8 hk_device_id[6];
					flash_read_page((unsigned long)flash_adr_layout.flash_adr_device_id, 6, hk_device_id);
                    memcpy(data + 2, hk_device_id, 6);
                    memcpy(otabuffer, data, 8);
                }
				break;

			case CMD_GET_HASH_ID:
                if(nDataLen == 0)
                {
					u8 hk_setupHash[4];
					flash_read_page((u32)(flash_adr_layout.flash_adr_hash_id), 4, hk_setupHash);
					memcpy(data + 2, hk_setupHash, 4);
                    memcpy(otabuffer, data, 6);
                }
				break;
			case CMD_GET_RSSI:
				if(nDataLen == 0)
				{
					short rssi_tmp = app_get_rssi();
					memcpy(data + 2, (u8 *)&rssi_tmp, 2);
					memcpy(otabuffer, data, 4);
				}
				break;
			#if SOFTWARE_AUTHENTICATION_ENABLE
			case CMD_SET_SW_AUTH_UUID:
				if(nDataLen == 16)
				{
					u32 flash_data = 0;
					u32 flash_data_2 = 0;
					flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_uuid, 4, (u8 *)&flash_data);
					flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_uuid + 16, 4, (u8 *)&flash_data_2);
					if((flash_data != 0xffffffff) || (flash_data_2 != 0xffffffff))
					{
						flash_erase_sector((unsigned long)flash_adr_layout.flash_adr_sw_uuid);
					}
					flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_uuid + 16, 16, parameter);
					flash_data = FLASH_FLAG_VALID;
					flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_uuid, 2, (u8 *)&flash_data);
					
					data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
					memcpy(otabuffer, data, 3);
					
				}
				break;
			case CMD_GET_SW_AUTH_UUID:
				if(nDataLen == 0)
				{
					u16 flash_data2 = 0;

					flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_uuid, 2, (u8 *)&flash_data2);
					if(flash_data2 == FLASH_FLAG_VALID)
					{
						u8 sw_uuid[16] = {0};
						flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_uuid + 16, 16, sw_uuid);
						memcpy(data + 2, sw_uuid, 16);
						memcpy(otabuffer, data, 18);
					}
					else
					{
						data[2] = CMD_SET_CUSTOM_VALUE_ERROR;
						memcpy(otabuffer, data, 3);
					}
				}
				break;
			case CMD_SET_SW_AUTH_TOKEN:
				if(nDataLen >= 2)
				{
					u32 flash_data3 = 0;
					u32 flash_data3_2 = 0;
					u16 wr_len = 0;
					bool len_err = true;
					if((token_wr_len == 0) && (token_wr_offset == 0) && (token_wr_index == -1) && (parameter[2] == 0)){
						wr_len = (parameter[0] | (parameter[1] << 8));
						if(wr_len <= 15){
							if(nDataLen + 2 != wr_len + 5) len_err = false;
						}else{
							if(nDataLen + 2 != 15 + 5) len_err = false;
						}
						if(len_err){
							CustVendorCmd_SoftAuth_rd_reset();		//SoftAuth read params must reset during write.
							flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token, 4, (u8 *)&flash_data3);
							flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16, 4, (u8 *)&flash_data3_2);
							if((flash_data3 != 0xffffffff) || (flash_data3_2 != 0xffffffff)){
								flash_erase_sector((unsigned long)flash_adr_layout.flash_adr_sw_token);
							}
							if(wr_len <= 15){
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16, wr_len, &parameter[3]);
								data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
								flash_data3 = FLASH_FLAG_VALID;
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token, 2, (u8 *)&flash_data3);
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 2, 2, (u8 *)&wr_len);
								token_wr_timeout = 0;
							}else{
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16, 15, &parameter[3]);
								token_wr_len = wr_len;
								token_wr_offset = 15;
								token_wr_index = parameter[2];
								data[2] = CMD_SET_CUSTOM_VALUE_UNCOMPLETED;
								token_wr_timeout = clock_time()|1;
							}
						}
						else{
							data[2] = CMD_SET_CUSTOM_VALUE_ERROR;
						}
					}
					else if((token_wr_len > token_wr_offset) && (token_wr_index + 1 == parameter[0]))
					{
						wr_len = token_wr_len - token_wr_offset;
						if(wr_len > 17){
							if(nDataLen + 2 != 17 + 3) len_err = false;
						}else{
							if(nDataLen + 2 != wr_len + 3) len_err = false;
						}
						if(len_err){
							CustVendorCmd_SoftAuth_rd_reset();		//SoftAuth read params must reset during write.
							if(wr_len > 17)
							{
								token_wr_index = parameter[0];
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16 + token_wr_offset, 17, &parameter[1]);
								token_wr_offset += 17;
								data[2] = CMD_SET_CUSTOM_VALUE_UNCOMPLETED;
								token_wr_timeout = clock_time()|1;
							}else{
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16 + token_wr_offset, wr_len, &parameter[1]);
								flash_data3 = FLASH_FLAG_VALID;
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token, 2, (u8 *)&flash_data3);
								flash_write_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 2, 2, (u8 *)&token_wr_len);
								token_wr_len = 0;
								token_wr_offset = 0;
								token_wr_index = -1;
								data[2] = CMD_SET_CUSTOM_VALUE_SUCCESS;
								token_wr_timeout = 0;
							}
						}
						else{
							data[2] = CMD_SET_CUSTOM_VALUE_ERROR;
						}
					}else{
						//TODO
						data[2] = CMD_SET_CUSTOM_VALUE_ERROR;
					}
					memcpy(otabuffer, data, 3);
				}
				break;
			case CMD_GET_SW_AUTH_TOKEN:
				if(nDataLen == 0)
				{
					u16 flash_data4 = 0;

					if((token_rd_len == 0) && (token_rd_offset == 0) && (token_rd_index == -1))
					{
						flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token, 2, (u8 *)&flash_data4);
						if(flash_data4 == FLASH_FLAG_VALID)
						{
							flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 2, 2, (u8 *)&token_rd_len);
							memcpy(data + 2, (u8 *)&token_rd_len, 2);
							token_rd_index += 1;
							data[4] = token_rd_index;
							if(token_rd_len > 15){
								flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16, 15, (u8 *)&data[5]);
								token_rd_offset = 15;
								memcpy(otabuffer, data, 20);
								token_rd_timeout = clock_time()|1;
							}else{
								flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16, token_rd_len, (u8 *)&data[5]);
								memcpy(otabuffer, data, (token_rd_len + 5));
								token_rd_index = -1;
								token_rd_len = 0;
								token_rd_timeout = 0;
							}
						}
						else
						{
							//TODO
							data[2] = CMD_SET_CUSTOM_VALUE_ERROR;
							memcpy(otabuffer, data, 3);
						}
					}
					else if(token_rd_len > token_rd_offset)
					{
						token_rd_index += 1;
						data[2] = token_rd_index;
						if(token_rd_len - 17 > token_rd_offset)
						{
							flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16 + token_rd_offset, 17, (u8 *)&data[3]);
							token_rd_offset += 17;
							memcpy(otabuffer, data, 20);
							token_rd_timeout = clock_time()|1;
						}
						else
						{
							flash_read_page((unsigned long)flash_adr_layout.flash_adr_sw_token + 16 + token_rd_offset, (token_rd_len - token_rd_offset), (u8 *)&data[3]);
							memcpy(otabuffer, data, 3 + (token_rd_len - token_rd_offset));
							token_rd_index = -1;
							token_rd_len = 0;
							token_rd_offset = 0;
							token_rd_timeout = 0;
						}
					}
					else
					{
						//TODO
						data[2] = CMD_SET_CUSTOM_VALUE_ERROR;
						memcpy(otabuffer, data, 3);
					}
				}
				break;
			#endif
            default:
                break;
        }
    }else if(CmdNo >= 0xFC00){

        enum{
            CMD_CUST00_GET_PRJ_MODEL    = (0xFC00),
            CMD_CUST01                  = (0xFC01),
            CMD_CUST02                  = (0xFC02),
            CMD_CUST03                  = (0xFC03),
            CMD_CUST04                  = (0xFC04),
            CMD_CUST05                  = (0xFC05),
            CMD_CUST99_REBOOT           = (0xFC99),
        };

        if(CmdNo == CMD_CUST00_GET_PRJ_MODEL){
            const char PRJ_MODEL[]="MODEL_201709";
            memcpy(otabuffer, PRJ_MODEL, (sizeof(PRJ_MODEL)-1));
        }else if(CmdNo == CMD_CUST01){
            ;
        }else if(CmdNo == CMD_CUST02){
            ;
            //-printf("got CMD_CUST02(%d)\n",nDataLen);
        }else if(CmdNo == CMD_CUST03){
            ;
            //-printf("got CMD_CUST03(%d)\n",nDataLen);
        }else if(CmdNo == CMD_CUST04){
            ;
            //-printf("got CMD_CUST04(%d)\n",nDataLen);
        }else if(CmdNo == CMD_CUST05){
            if(nDataLen > 0)
                memcpy(otabuffer, parameter, nDataLen);
            //-printf("got CMD_CUST05(%d)\n",nDataLen);
            //-for(; nDataLen>0; nDataLen--)
            //-    printf("%2X\t", parameter[nDataLen-1]);
            //-printf("\n");
        }else if(CmdNo == CMD_CUST99_REBOOT){
            //R10 clear broadcast event param.
            extern void blt_clean_broadcast_param(void);
            blt_clean_broadcast_param();
            rf_led_ota_ok();
            start_reboot();
        }
    }
}
