/*
 * hk_tc_simulate.c
 *
 *  Created on: 2019-2-15
 *      Author: Administrator
 */

/******************************************************
 * 				hk test case simulate
 *****************************************************/
#include "../app_att.h"
#include "../hk_TopUUID.h"
#include "homekit_src/hk_adv_packet.h"
#include "../../../homekit_src/hk_ble_ll_ota.h"


#include "hk_tc_simulate.h"

#if HK_TEST_CASE_SIMULATE_ENABLE

#define 	MY_ADV_INTERVAL_MIN2					ADV_INTERVAL_20MS
#define 	MY_ADV_INTERVAL_MAX2					ADV_INTERVAL_30MS
#define 	MY_DISCONN_EVT_ADV_INTERVAL_MIN2		ADV_INTERVAL_20MS
#define 	MY_DISCONN_EVT_ADV_INTERVAL_MAX2		ADV_INTERVAL_20MS

_attribute_data_retention_ extern u8 EventNotifyCNT;
_attribute_data_retention_ extern u8 DoBroadcastEncrypDataCALL_flag;
_attribute_data_retention_ extern u8 ReCheckAndRestoreFlashCharValueFlag;

_attribute_data_retention_ extern u32 broadcast_encryption_time_timeout;
_attribute_data_retention_ extern u32 disconnect_event_time_timeout;

extern u8 hkble_ota_data_check;
extern unsigned int  store_char_change_value_timeout;
extern st_ll_conn_slave_t		bltc;

 _attribute_data_retention_ extern u32 remove_invalid_srpkey_timeout;


extern u8 dev_characteristic_store_to_flash(void);

/************************************************************************
 * 					UI,LED, PROC TASK
 ***********************************************************************/
void proc_ui_simulate(void) {

    static u32 btn_sw2_pre2 = 1;
	static u32 btn_sw3_pre2 = 1;
	static u32 btn_sw4_pre2 = 1;
	static u32 btn_sw5_pre2 = 1;
	u32 b1 = 0;
	u32 b2 = 0;

	#if LIGHTBULB_SERVICE_ENABLE
	u8 gsn_modify_temp = blt_adv_global_state_modify_once;	//just implement lightblue service test.
	#endif
	
	gpio_write(BUTTON_SW2_SW3_BASE, 0);
	gpio_write(BUTTON_SW4_SW5_BASE, 1);
	sleep_us(1);
    b1 = gpio_read(BUTTON_SW2_SW4_PIN);		//SW2
	b2 = gpio_read(BUTTON_SW3_SW5_PIN);		//SW3
	
    if (!b1 && btn_sw2_pre2) {
        /////////////////////////////////
        // do key1 action here!
        /////////////////////////////////
#if GARAGEDOOROPENER_SERVICE_ENABLE
		if(Current_Door_State == 3)
		{
			Obstruction_Detected = 1;
			Current_Door_State = 0;
			Target_Door_State = 0;
			
			store_char_value_to_flash();
			
			if(EventNotifyCNT)
				if(bltc.conn_terminate_pending == 0)
				{
					if(indicate_handle_no_send_once_after_checkit(GDOPENER_HANDLE_NUM_OBSTRUCTIONDETECTED) == 1)
						sleep_us(250);
					if(indicate_handle_no_send_once_after_checkit(GDOPENER_HANDLE_NUM_CURRENTDOORTSTATE) == 1)
						sleep_us(250);
					if(indicate_handle_no_send_once_after_checkit(GDOPENER_HANDLE_NUM_TARGETDOORSTATE) == 1)
						sleep_us(250);
				}
				
			blt_adv_set_global_state ();
			if( blt_state == BLS_LINK_STATE_ADV)
			{
	#if 0	//need to modify.
				if(bc_para_light_on & BIT(7)){
				blt_broadcast_set_global_state();
				DoBroadcastEncrypDataCALL_flag++;
				}else if(gsn_modify_temp){
					bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
					disconnect_event_time_timeout = clock_time() | 1;
				}
	#endif
			}
		}
#endif
		
#if LIGHTBULB_SERVICE_ENABLE

		light_onoff = !light_onoff;
        store_char_value_to_flash();
		
        if(EventNotifyCNT)
            if(bltc.conn_terminate_pending == 0)
            {
                if(indicate_handle_no_send_once_after_checkit(LIGHTBULB_HANDLE_NUM_LIGHT_ONOFF) == 1)
                    sleep_us(250);
            }
			
        blt_adv_set_global_state ();
		if( blt_state == BLS_LINK_STATE_ADV)
		{
			#if 1
			if(bc_para_light_on & BIT(7)){
			blt_broadcast_set_global_state();
			DoBroadcastEncrypDataCALL_flag++;
			}else if(gsn_modify_temp){
				bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
				disconnect_event_time_timeout = clock_time() | 1;
			}
			#endif
		}
    	
    	pwm_light_enable (light_onoff);
#endif  //for LIGHTBULB_SERVICE_ENABLE action

#if WINDOW_SERVICE_ENABLE
	if(((hWindowTargetPosition < hWindowTargetPosition_temp) && (hWindowPositionState == 0)) || \
		((hWindowTargetPosition > hWindowTargetPosition_temp) && (hWindowPositionState == 1)))
	{
		hWindowPositionState = 2;
		hWindowCurrentPosition = hWindowTargetPosition;
		store_char_value_to_flash();
		
		if(EventNotifyCNT)
			if(bltc.conn_terminate_pending == 0)
			{
				if(indicate_handle_no_send_once_after_checkit(WINDOW_HANDLE_NUM_POSITIONSTATE) == 1)
					sleep_us(250);
				if(indicate_handle_no_send_once_after_checkit(WINDOW_HANDLE_NUM_CURRENTPOSITION) == 1)
					sleep_us(250);
			}
		blt_adv_set_global_state ();
	}
	hWindowTargetPosition_temp = hWindowTargetPosition;

#if CHAR_WINDOW_HOLDPOSITION_ENABLE
	hWindowHoldPosition = !hWindowHoldPosition;
#endif

#endif

#if DOOR_SERVICE_ENABLE
	hDoorTargetPosition = 0;
	hDoorPositionState = 0;
	store_char_value_to_flash();
	if(EventNotifyCNT)
		if(bltc.conn_terminate_pending == 0)
		{
			if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_TARGETPOSITION) == 1)
				sleep_us(250);
			if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_POSITIONSTATE) == 1)
				sleep_us(250);
		}
	blt_adv_set_global_state ();
#endif


#if LOCKMECHANISM_SERVICE_ENABLE

		Lock_Current_State = !Lock_Current_State;
		Lock_Target_State = Lock_Current_State;
        store_char_value_to_flash();
		
        if(EventNotifyCNT)
            if(bltc.conn_terminate_pending == 0)
            {
                if(indicate_handle_no_send_once_after_checkit(LOCKMECHANISM_HANDLE_NUM_LOCKCURRENTSTATE) == 1)
                    sleep_us(250);
				if(indicate_handle_no_send_once_after_checkit(LOCKMECHANISM_HANDLE_NUM_LOCKTARGETSTATE) == 1)
					sleep_us(250);
            }
			
        blt_adv_set_global_state ();
		if( blt_state == BLS_LINK_STATE_ADV)
		{
			#if 0	//need to modify.
			if(bc_para_light_on & BIT(7)){
			blt_broadcast_set_global_state();
			DoBroadcastEncrypDataCALL_flag++;
			}else if(gsn_modify_temp){
				bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
				disconnect_event_time_timeout = clock_time() | 1;
			}
			#endif
		}
#endif  //for LOCKMECHANISM_SERVICE_ENABLE action

#if OUTLET_SERVICE_ENABLE

	hOutletInUse = !hOutletInUse;
	store_char_value_to_flash();
	
	if(EventNotifyCNT)
		if(bltc.conn_terminate_pending == 0)
		{
			if(indicate_handle_no_send_once_after_checkit(OUTLET_HANDLE_NUM_INUSE) == 1)
				sleep_us(250);
		}
		
	blt_adv_set_global_state ();
	if( blt_state == BLS_LINK_STATE_ADV)
	{
	#if 0
		if(bc_para_light_on & BIT(7)){
		blt_broadcast_set_global_state();
		DoBroadcastEncrypDataCALL_flag++;
		}else if(gsn_modify_temp){
			bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
			disconnect_event_time_timeout = clock_time() | 1;
		}
	#endif
	}
	
#endif

#if THERMOSTAT_SERVICE_ENABLE

	if((hThermostatTargetHeatingCoolingState == 1) || (hThermostatTargetHeatingCoolingState == 2))	//1: heat, 2: cool
	{
		//hThermostatTargetTemperature = 0x41c80000;	//25.0
		//hThermostatTargetTemperature = 0x41700000;	//15.0
		hThermostatCurrentTemperature = hThermostatTargetTemperature;
		hThermostatCurrentHeatingCoolingState = 0;
	}
	else if(hThermostatTargetHeatingCoolingState == 3)	//Auto
	{
		if(hThermostatCoolingThresholdTemperature == 0x41b80000)	//23.0 > 20.0
		{
			hThermostatCurrentTemperature = hThermostatCoolingThresholdTemperature;
			hThermostatCurrentHeatingCoolingState = 2;	//cool
		}else if(hThermostatHeatingThresholdTemperature == 0x41880000)	//17.0 > 20.0
		{
			hThermostatCurrentTemperature = hThermostatHeatingThresholdTemperature;
			hThermostatCurrentHeatingCoolingState = 1;	//heat
		}
	}
	store_char_value_to_flash();
	
	if(EventNotifyCNT)
		if(bltc.conn_terminate_pending == 0)
		{
			if(indicate_handle_no_send_once_after_checkit(THERMOSTAT_HANDLE_NUM_CURRENTTEMPERATURE) == 1)
				sleep_us(250);
			if(indicate_handle_no_send_once_after_checkit(THERMOSTAT_HANDLE_NUM_CURRENTHEATINGCOOLINGSTATE) == 1)
				sleep_us(250);

		}
		
	blt_adv_set_global_state ();
	if( blt_state == BLS_LINK_STATE_ADV)
	{
#if 0
		if(bc_para_light_on & BIT(7)){
		blt_broadcast_set_global_state();
		DoBroadcastEncrypDataCALL_flag++;
		}else if(gsn_modify_temp){
			bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
			disconnect_event_time_timeout = clock_time() | 1;
		}
#endif
	}
#endif

#if HUMIDIFIER_DEHUMIDIFIER_SERVICE_ENABLE
	
	hHumidifierDehumidifierCurrentRelativeHumidity = hHumidifierDehumidifierRelativeHumidityDehumidifierThreshold;
	
	hHumidifierDehumidifierCurrentHumidifierDehumidifierState = 3;

	store_char_value_to_flash();
	
	if(EventNotifyCNT)
		if(bltc.conn_terminate_pending == 0)
		{
			if(indicate_handle_no_send_once_after_checkit(HUMIDIFIERDEHUMIDIFIER_HANDLE_NUM_CURRENTRELATIVEHUMIDITY) == 1)
				sleep_us(250);
			if(indicate_handle_no_send_once_after_checkit(HUMIDIFIERDEHUMIDIFIER_HANDLE_NUM_CURRENTHUMIDIFIERDEHUMIDIFIERSTATE) == 1)
				sleep_us(250);

		}
		
	blt_adv_set_global_state ();
	if( blt_state == BLS_LINK_STATE_ADV)
	{
#if 0
		if(bc_para_light_on & BIT(7)){
		blt_broadcast_set_global_state();
		DoBroadcastEncrypDataCALL_flag++;
		}else if(gsn_modify_temp){
			bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
			disconnect_event_time_timeout = clock_time() | 1;
		}
#endif
	}

#endif

#if IRRIGATION_SYSTEM_SERVICE_ENABLE

	if(0 == hIrrigationSystemActive)
	{
		hIrrigationSystemActive = 1;
	}
	else if(1 == hIrrigationSystemActive)
	{
		hIrrigationSystemActive = 0;
		hIrrigationSystemInUse = 0;
		hValveActive = 0;
		hValveInUse = 0;
		hValveRemainingDuration = 0;
		hValvecountdown_timeout = 0;
		
		#if VALVE2_SERVICE_ENABLE
		hValve2Active = 0;
		hValve2InUse = 0;
		hValve2RemainingDuration = 0;
		hValve2countdown_timeout = 0;
		#endif
	}
	store_char_value_to_flash();
	if(EventNotifyCNT)
		if(bltc.conn_terminate_pending == 0)
		{
			if(indicate_handle_no_send_once_after_checkit(IRRIGATIONSYSTEM_HANDLE_NUM_ACTIVE) == 1)
				sleep_us(250);
		}
	blt_adv_set_global_state ();

	if( blt_state == BLS_LINK_STATE_ADV)
	{
#if 0
		if(bc_para_light_on & BIT(7)){
		blt_broadcast_set_global_state();
		DoBroadcastEncrypDataCALL_flag++;
		}else if(gsn_modify_temp){
			bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
			disconnect_event_time_timeout = clock_time() | 1;
		}
#endif
	}
	
#endif

#if FAUCET_SERVICE_ENABLE
	if((1 == hFaucetActive) && (1 == hValveActive))
	{
		hValveInUse = 1;
		store_char_value_to_flash();
		if(EventNotifyCNT)
			if(bltc.conn_terminate_pending == 0)
			{
				if(indicate_handle_no_send_once_after_checkit(VALVE_HANDLE_NUM_INUSE) == 1)
					sleep_us(250);
			}
		blt_adv_set_global_state ();
		if( blt_state == BLS_LINK_STATE_ADV && (bc_para_hValveInUse & BIT(7)))
		{
			#if 1
			blt_broadcast_set_global_state();
			DoBroadcastEncrypDataCALL_flag++;
		
			#endif
		}
	}
#endif

#if STATELESS_PROG_SW_SERVICE_ENABLE

	hStateless_Prog_Sw_pressDown = true;
	if(hStateless_Prog_Sw_pressCnts == 0)
	{
		hStateless_Prog_Sw_pressCnts = 1;
		hStateless_Prog_Sw_timeout = clock_time() | 1;
	}
	else
	{
		if(hStateless_Prog_Sw_timeout != 0)
			hStateless_Prog_Sw_pressCnts++;
	}
#endif

#if DBG_UART_SHOW_APPEND_PROC_TIME
        uart_proc_time_max = 0;
#endif

    }
    btn_sw2_pre2 = b1;

    if (!b2 && btn_sw3_pre2) {

#if (LIGHTBULB_SERVICE_ENABLE && CHAR_BRIGHTNESS_ENABLE)

		if(light_brightness != 0)
        	light_brightness = 0;
		else
			light_brightness = 90;
        store_char_value_to_flash();
		
        if(EventNotifyCNT)
            if(bltc.conn_terminate_pending == 0)
            {
                if(indicate_handle_no_send_once_after_checkit(LIGHTBULB_HANDLE_NUM_LIGHT_BRIGHTNESS) == 1)
                    sleep_us(250);
            }
			
        blt_adv_set_global_state ();
		if( blt_state == BLS_LINK_STATE_ADV)
		{
	#if 1
			if(bc_para_light_bri & BIT(7)){
			blt_broadcast_set_global_state();
			DoBroadcastEncrypDataCALL_flag++;
			}else if(gsn_modify_temp){
				bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
				disconnect_event_time_timeout = clock_time() | 1;
			}
	#endif
		}
		
		extern void Convert_HSV2RGB(u32 * dbg);
		u32 dbg2 = 0;
		Convert_HSV2RGB(&dbg2);
#endif  //for LIGHTBULB_SERVICE_ENABLE action

#if WINDOW_COVERING_SERVICE_ENABLE
	if(((hWindow_CoveringTargetPosition < hWindow_CoveringTargetPosition_temp) && (hWindow_CoveringPositionState == 0)) || \
		((hWindow_CoveringTargetPosition > hWindow_CoveringTargetPosition_temp) && (hWindow_CoveringPositionState == 1)))
	{
		hWindow_CoveringPositionState = 2;
		hWindow_CoveringCurrentPosition = hWindow_CoveringTargetPosition;
		store_char_value_to_flash();
		if(EventNotifyCNT)
			if(bltc.conn_terminate_pending == 0)
			{
				if(indicate_handle_no_send_once_after_checkit(WINDOWCOVERING_HANDLE_NUM_POSITIONSTATE) == 1)
					sleep_us(250);
				if(indicate_handle_no_send_once_after_checkit(WINDOWCOVERING_HANDLE_NUM_CURRENTPOSITION) == 1)
					sleep_us(250);
			}
		blt_adv_set_global_state ();
	}
	hWindow_CoveringTargetPosition_temp = hWindow_CoveringTargetPosition;

#endif

#if DOOR_SERVICE_ENABLE
	hDoorCurrentPosition = 0;
	hDoorPositionState = 2;
	store_char_value_to_flash();
	if(EventNotifyCNT)
		if(bltc.conn_terminate_pending == 0)
		{
			if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_POSITIONSTATE) == 1)
				sleep_us(250);
			if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_CURRENTPOSITION) == 1)
				sleep_us(250);
		}
	blt_adv_set_global_state ();
#endif

#if HUMIDIFIER_DEHUMIDIFIER_SERVICE_ENABLE
	
		hHumidifierDehumidifierCurrentRelativeHumidity = hHumidifierDehumidifierRelativeHumidityHumidifierThreshold;
		
		hHumidifierDehumidifierCurrentHumidifierDehumidifierState = 2;
	
		store_char_value_to_flash();
		
		if(EventNotifyCNT)
			if(bltc.conn_terminate_pending == 0)
			{
				if(indicate_handle_no_send_once_after_checkit(HUMIDIFIERDEHUMIDIFIER_HANDLE_NUM_CURRENTRELATIVEHUMIDITY) == 1)
					sleep_us(250);
				if(indicate_handle_no_send_once_after_checkit(HUMIDIFIERDEHUMIDIFIER_HANDLE_NUM_CURRENTHUMIDIFIERDEHUMIDIFIERSTATE) == 1)
					sleep_us(250);
	
			}
			
		blt_adv_set_global_state ();
		if( blt_state == BLS_LINK_STATE_ADV)
		{
#if 0
			if(bc_para_light_on & BIT(7)){
			blt_broadcast_set_global_state();
			DoBroadcastEncrypDataCALL_flag++;
			}else if(gsn_modify_temp){
				bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
				disconnect_event_time_timeout = clock_time() | 1;
			}
#endif
		}
		
#endif

#if IRRIGATION_SYSTEM_SERVICE_ENABLE
	
			hIrrigationSystemInUse = !hIrrigationSystemInUse;
			
			hValveActive = !hValveActive;
			hValveInUse = !hValveInUse;
			store_char_value_to_flash();
			if(EventNotifyCNT)
				if(bltc.conn_terminate_pending == 0)
				{
					if(indicate_handle_no_send_once_after_checkit(IRRIGATIONSYSTEM_HANDLE_NUM_INUSE) == 1)
						sleep_us(250);
					if(indicate_handle_no_send_once_after_checkit(VALVE_HANDLE_NUM_INUSE) == 1)
						sleep_us(250);
				}
			blt_adv_set_global_state ();
			if( blt_state == BLS_LINK_STATE_ADV)
			{
				#if 0
				if(bc_para_light_on & BIT(7)){
				blt_broadcast_set_global_state();
				DoBroadcastEncrypDataCALL_flag++;
				}else if(gsn_modify_temp){
					bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
					disconnect_event_time_timeout = clock_time() | 1;
				}
				#endif
			}

	
			if(hValveInUse == 1)
			{
				hValveRemainingDuration = hValveSetDuration;
				hValvecountdown_timeout = clock_time() | 1;
			}
			else
			{
				hValvecountdown_timeout = 0;
				hValveRemainingDuration = 0;
			}
	
#endif

#if STATELESS_PROG_SW2_SERVICE_ENABLE
	
		hStateless_Prog_Sw2_pressDown = true;
		if(hStateless_Prog_Sw2_pressCnts == 0)
		{
			hStateless_Prog_Sw2_pressCnts = 1;
			hStateless_Prog_Sw2_timeout = clock_time() | 1;
		}
		else
		{
			if(hStateless_Prog_Sw2_timeout != 0)
				hStateless_Prog_Sw2_pressCnts++;
		}
#endif

    }
    btn_sw3_pre2 = b2;


	gpio_write(BUTTON_SW2_SW3_BASE, 1);
	gpio_write(BUTTON_SW4_SW5_BASE, 0);
	sleep_us(1);
    b1 = gpio_read(BUTTON_SW2_SW4_PIN);		//SW4
	b2 = gpio_read(BUTTON_SW3_SW5_PIN);		//SW5

    if (!b1 && btn_sw4_pre2) {

#if (LIGHTBULB_SERVICE_ENABLE && CHAR_HUE_ENABLE)

		if(hue_value != 0)
        	hue_value = 0;
		else
			hue_value = 0x42C80000;	//100.0
        store_char_value_to_flash();
		
        if(EventNotifyCNT)
            if(bltc.conn_terminate_pending == 0)
            {
                if(indicate_handle_no_send_once_after_checkit(LIGHTBULB_HANDLE_NUM_HUE_VALUE) == 1)
                    sleep_us(250);
            }
        blt_adv_set_global_state ();
			
		if( blt_state == BLS_LINK_STATE_ADV)
		{
			#if 1
			if(bc_para_light_hue & BIT(7)){
			blt_broadcast_set_global_state();
			DoBroadcastEncrypDataCALL_flag++;
			}else if(gsn_modify_temp){
				bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
				disconnect_event_time_timeout = clock_time() | 1;
			}
			#endif
		}
			
		extern void Convert_HSV2RGB(u32 * dbg);
		u32 dbg2 = 0;
		Convert_HSV2RGB(&dbg2);
#endif  //for LIGHTBULB_SERVICE_ENABLE action

#if DOOR_SERVICE_ENABLE
		hDoorTargetPosition = 100;
		hDoorPositionState = 1;
		store_char_value_to_flash();
		if(EventNotifyCNT)
			if(bltc.conn_terminate_pending == 0)
			{
				if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_TARGETPOSITION) == 1)
					sleep_us(250);
				if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_POSITIONSTATE) == 1)
					sleep_us(250);
			}
		blt_adv_set_global_state ();
#endif


#if (IRRIGATION_SYSTEM_SERVICE_ENABLE && VALVE2_SERVICE_ENABLE)
	
			hIrrigationSystemInUse = !hIrrigationSystemInUse;
	
			hValve2Active = !hValve2Active;
			hValve2InUse = !hValve2InUse;
			store_char_value_to_flash();
			if(EventNotifyCNT)
				if(bltc.conn_terminate_pending == 0)
				{
					if(indicate_handle_no_send_once_after_checkit(IRRIGATIONSYSTEM_HANDLE_NUM_INUSE) == 1)
						sleep_us(250);
					if(indicate_handle_no_send_once_after_checkit(VALVE2_HANDLE_NUM_INUSE) == 1)
						sleep_us(250);
				}
			blt_adv_set_global_state ();
			if( blt_state == BLS_LINK_STATE_ADV)
			{
				#if 0
				if(bc_para_light_on & BIT(7)){
				blt_broadcast_set_global_state();
				DoBroadcastEncrypDataCALL_flag++;
				}else if(gsn_modify_temp){
					bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
					disconnect_event_time_timeout = clock_time() | 1;
				}
				#endif
			}

	
			if(hValve2InUse == 1)
			{
				hValve2RemainingDuration = hValve2SetDuration;
				hValve2countdown_timeout = clock_time() | 1;
			}
			else
			{
				hValve2countdown_timeout = 0;
				hValve2RemainingDuration = 0;
			}
	
#endif

    }
    btn_sw4_pre2 = b1;

    if (!b2 && btn_sw5_pre2) {

#if (LIGHTBULB_SERVICE_ENABLE && CHAR_SATURATION_ENABLE)

		if(saturation_value != 0)
        	saturation_value = 0;
		else
			saturation_value = 0x42480000;	//50.0
        store_char_value_to_flash();
		
        if(EventNotifyCNT)
            if(bltc.conn_terminate_pending == 0)
            {
                if(indicate_handle_no_send_once_after_checkit(LIGHTBULB_HANDLE_NUM_SATURATION_VALUE) == 1)
                    sleep_us(250);
            }
			
        blt_adv_set_global_state ();
		if( blt_state == BLS_LINK_STATE_ADV)
		{
			#if 1
			if(bc_para_light_satu & BIT(7)){
			blt_broadcast_set_global_state();
			DoBroadcastEncrypDataCALL_flag++;
			}else if(gsn_modify_temp){
				bls_ll_setAdvInterval(MY_DISCONN_EVT_ADV_INTERVAL_MIN2, MY_DISCONN_EVT_ADV_INTERVAL_MAX2); // disconnect event adv interval = 20ms
				disconnect_event_time_timeout = clock_time() | 1;
			}
			#endif
		}
			
		extern void Convert_HSV2RGB(u32 * dbg);
		u32 dbg2 = 0;
		Convert_HSV2RGB(&dbg2);
#endif  //for LIGHTBULB_SERVICE_ENABLE action

#if DOOR_SERVICE_ENABLE
	hDoorCurrentPosition = 85;
	hDoorTargetPosition = 85;
	hDoorPositionState = 2;
	store_char_value_to_flash();
	if(EventNotifyCNT)
		if(bltc.conn_terminate_pending == 0)
		{
			if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_POSITIONSTATE) == 1)
				sleep_us(250);
			if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_CURRENTPOSITION) == 1)
				sleep_us(250);
			if(indicate_handle_no_send_once_after_checkit(DOOR_HANDLE_NUM_TARGETPOSITION) == 1)
				sleep_us(250);
		}
	blt_adv_set_global_state ();
#endif
    }
    btn_sw5_pre2 = b2;
}


/////////////////////////////////////////////////////////////////////
// main loop flow
/////////////////////////////////////////////////////////////////////



void main_loop_simulate (void)
{
	////////////////////////////////////// BLE entry /////////////////////////////////
	blt_sdk_main_loop();

	if (blt_state == BLS_LINK_STATE_CONN )
	{
		hk_l2cap_att_main_loop();
	}
	

	////////////////////////////////////// UI entry /////////////////////////////////

	if(hkble_ota_data_check != HKBLE_OTA_DATA_NONE)
	{

#if (HKBLE_OTA_DATA_VERIFY_AFTER_SAVE_EN)
		extern int hkble_hk_ota_adr_index;
		extern void hkble_ota_verify_data_from_flash(void);
		extern void hkble_hk_ota_verify_data_from_flash(void);
		
		if(hkble_ota_data_check == HKBLE_OTA_DATA_END)
		{
			if( hkble_ota_adr_index >=0 )
			{
				hkble_ota_verify_data_from_flash();
				hkble_ota_data_check = HKBLE_OTA_DATA_NONE;
			}

			if( hkble_hk_ota_adr_index >= 0 )
			{
				hkble_hk_ota_verify_data_from_flash();
				hkble_ota_data_check = HKBLE_OTA_DATA_NONE;
			}
		}
		else if(hkble_ota_data_timeout && clock_time_exceed(hkble_ota_data_timeout, 4*1000*1000))
		{
			/*OTA data timeout*/
			if(hkble_ota_adr_index >= 0)
			{
				hkble_ota_verify_data_from_flash();
				hkble_ota_data_check = HKBLE_OTA_DATA_NONE;
			}

			if( hkble_hk_ota_adr_index >= 0 )
			{
				hkble_hk_ota_verify_data_from_flash();
				hkble_ota_data_check = HKBLE_OTA_DATA_NONE;
			}
		}
#else
		if(hkble_ota_data_timeout && clock_time_exceed(hkble_ota_data_timeout, 10000*1000))
		{
			/*OTA data timeout*/
			if((hkble_ota_adr_index >= 0) || (hkble_hk_ota_adr_index >= 0))
			{
				bls_ll_terminateConnection(0x13);
				rf_led_ota_error();
				start_reboot();
			}
		}
#endif
	}
	else
	{
#if LIGHTBULB_SERVICE_ENABLE

		if (ReCheckAndRestoreFlashCharValueFlag == 1)
		{
			ReCheckAndRestoreFlashCharValueFlag = 2;
			light_brightness = 100;
			hue_value = 0x420C0000;
			saturation_value = 0x429E0000;
			#if 1
			extern u8 dev_characteristic_store_to_flash(void);
			dev_characteristic_store_to_flash();
			#else
			flash_erase_sector(flash_char_value_addr);
			#endif
			extern void dev_char_val_restore_from_flash(void);
			dev_char_val_restore_from_flash();
		}

		// TODO:  bc_para_light_on	in ram, lost when power-on
		if( DoBroadcastEncrypDataCALL_flag && blt_state == BLS_LINK_STATE_ADV && (bc_para_light_on & BIT(7)))
		{
			broadcast_encryption_time_timeout = clock_time()|1;
			DoBroadcastEncrypDataCALL_flag = 0;
			u8 tmp_data[8];
			memset(tmp_data, 0, 8);
			tmp_data[0] = light_onoff;
			blt_set_encryption_broadcast_pkt(insts[LIGHTBULB_INST_NO+2], tmp_data);
			set_broadcast_adv_interval(bc_para_light_on);
		}

		#if CHAR_BRIGHTNESS_ENABLE
		if( DoBroadcastEncrypDataCALL_flag && blt_state == BLS_LINK_STATE_ADV && (bc_para_light_bri & BIT(7)))
		{
			broadcast_encryption_time_timeout = clock_time()|1;
			DoBroadcastEncrypDataCALL_flag = 0;
			int tmp_data[2];
			memset((u8*)tmp_data, 0, 8);
			tmp_data[0] = light_brightness;
			blt_set_encryption_broadcast_pkt(insts[LIGHTBULB_INST_NO+3], (u8 *)tmp_data);
			set_broadcast_adv_interval(bc_para_light_bri);
		}
		#endif

		#if CHAR_HUE_ENABLE
		if( DoBroadcastEncrypDataCALL_flag && blt_state == BLS_LINK_STATE_ADV && (bc_para_light_hue & BIT(7)))
		{
			broadcast_encryption_time_timeout = clock_time()|1;
			DoBroadcastEncrypDataCALL_flag = 0;
			u32 tmp_data[2];
			memset((u8*)tmp_data, 0, 8);
			tmp_data[0] = hue_value;
			blt_set_encryption_broadcast_pkt(insts[LIGHTBULB_INST_NO+4], (u8 *)tmp_data);
			set_broadcast_adv_interval(bc_para_light_hue);
		}
		#endif

		#if CHAR_SATURATION_ENABLE
		if( DoBroadcastEncrypDataCALL_flag && blt_state == BLS_LINK_STATE_ADV && (bc_para_light_satu & BIT(7)))
		{
			broadcast_encryption_time_timeout = clock_time()|1;
			DoBroadcastEncrypDataCALL_flag = 0;
			u32 tmp_data[2];
			memset((u8*)tmp_data, 0, 8);
			tmp_data[0] = saturation_value;
			blt_set_encryption_broadcast_pkt(insts[LIGHTBULB_INST_NO+5], (u8 *)tmp_data);
			set_broadcast_adv_interval(bc_para_light_satu);
		}
		#endif
#endif

#if SECURITY_SERVICE_ENABLE
		
		extern u32 hSecurity_notify_timeout;
		extern u8 hSecurityTargetState_notify_enable;
	
		if(hSecurity_notify_timeout && clock_time_exceed(hSecurity_notify_timeout, 1000*1000))
		{
			hSecurity_notify_timeout = 0;
			if(hSecurityTargetState_notify_enable == 1)
			{
				if(indicate_handle_no_send_once_after_checkit(SECURITY_HANDLE_NUM_TARGETSTATE) == 1)
					sleep_us(250);
			}
			if(indicate_handle_no_send_once_after_checkit(SECURITY_HANDLE_NUM_CURRENTSTATE) == 1)
				sleep_us(250);
		}
#endif

#if IRRIGATION_SYSTEM_SERVICE_ENABLE
		
		
		if(hValvecountdown_timeout && clock_time_exceed(hValvecountdown_timeout, 1000*1000)){
			
			hValvecountdown_timeout = clock_time() | 1;
			
			if(--hValveRemainingDuration == 0)
			{
				hValvecountdown_timeout = 0;
				if((hValveInUse == 1) && (hIrrigationSystemInUse == 1))
				{
					hValveInUse = 0;
					hValveActive = 0;
					hIrrigationSystemInUse = 0;
					store_char_value_to_flash();
					if(EventNotifyCNT)
						if(bltc.conn_terminate_pending == 0)
						{
							if(indicate_handle_no_send_once_after_checkit(IRRIGATIONSYSTEM_HANDLE_NUM_INUSE) == 1)
								sleep_us(250);
							if(indicate_handle_no_send_once_after_checkit(VALVE_HANDLE_NUM_INUSE) == 1)
								sleep_us(250);
							if(indicate_handle_no_send_once_after_checkit(VALVE_HANDLE_NUM_REMAININGDURATION) == 1)
								sleep_us(250);
						}
					blt_adv_set_global_state ();
					#if 0
					if( blt_state == BLS_LINK_STATE_ADV && (bc_para_hIrrigationSystemActive & BIT(7)) && \
						(bc_para_hValveInUse & BIT(7)) && (bc_para_hValveRemainingDuration & BIT(7)))
					{
				#if 1
						blt_broadcast_set_global_state();
						DoBroadcastEncrypDataCALL_flag++;
					
				#endif
					}
					#endif
				}
			}
		
		}
		
		#if VALVE2_SERVICE_ENABLE
		if(hValve2countdown_timeout && clock_time_exceed(hValve2countdown_timeout, 1000*1000)){
			
			hValve2countdown_timeout = clock_time() | 1;
			
			if(--hValve2RemainingDuration == 0)
			{
				hValve2countdown_timeout = 0;
				if((hValve2InUse == 1) && (hIrrigationSystemInUse == 1))
				{
					hValve2InUse = 0;
					hValve2Active = 0;
					hIrrigationSystemInUse = 0;
					store_char_value_to_flash();
					if(EventNotifyCNT)
						if(bltc.conn_terminate_pending == 0)
						{
							if(indicate_handle_no_send_once_after_checkit(IRRIGATIONSYSTEM_HANDLE_NUM_INUSE) == 1)
								sleep_us(250);
							if(indicate_handle_no_send_once_after_checkit(VALVE2_HANDLE_NUM_INUSE) == 1)
								sleep_us(250);
							if(indicate_handle_no_send_once_after_checkit(VALVE2_HANDLE_NUM_REMAININGDURATION) == 1)
								sleep_us(250);
						}
					blt_adv_set_global_state ();
						
					#if 0
					if( blt_state == BLS_LINK_STATE_ADV && (bc_para_hIrrigationSystemActive & BIT(7)) && \
						(bc_para_hValve2InUse & BIT(7)) && (bc_para_hValve2RemainingDuration & BIT(7)))
					{
				#if 1
						blt_broadcast_set_global_state();
						DoBroadcastEncrypDataCALL_flag++;
					
				#endif
					}
					#endif
				}
			}
		
		}
		#endif
		
		
#endif

#if STATELESS_PROG_SW_SERVICE_ENABLE

			if((hStateless_Prog_Sw_pressCnts > 0) && hStateless_Prog_Sw_timeout && clock_time_exceed(hStateless_Prog_Sw_timeout, 1000*1000))
			{
				static u8 hStateless_Prog_Sw_pressCnts_tmp = 0;
				hStateless_Prog_Sw_pressCnts_tmp = hStateless_Prog_Sw_pressCnts;
				
				hStateless_Prog_Sw_timeout = 0;

				if(hStateless_Prog_Sw_pressCnts == 1)
				{
					if(hStateless_Prog_Sw_pressDown)
					{
						gpio_write(BUTTON_SW2_SW3_BASE, 0);
						gpio_write(BUTTON_SW4_SW5_BASE, 1);
						sleep_us(1);
						u32 b1 = gpio_read(BUTTON_SW2_SW4_PIN); 	//SW2
						//u32 b2 = gpio_read(BUTTON_SW3_SW5_PIN); 	//SW3
						if(b1 == 0)		//SW2 keep the status of press down.
						{
							hStateless_Prog_Sw_ProgSwEvent = 2;
						}
						else
						{
							hStateless_Prog_Sw_pressDown = false;
						}
					}
					if(!hStateless_Prog_Sw_pressDown)
					{
						hStateless_Prog_Sw_ProgSwEvent = 0;
					}
				}
				else if(hStateless_Prog_Sw_pressCnts == 2)
				{
					hStateless_Prog_Sw_ProgSwEvent = 1;
				}

				if(hStateless_Prog_Sw_pressCnts <= 2)
				{
					store_char_value_to_flash();
					
					if(EventNotifyCNT)
						if(bltc.conn_terminate_pending == 0)
						{
							if(indicate_handle_no_send_once_after_checkit(STATELESSPROGSW_HANDLE_NUM_PROGSWEVENT) == 1)
								sleep_us(250);
						}
						
					blt_adv_set_global_state ();
				}
				hStateless_Prog_Sw_pressCnts = 0;
				hStateless_Prog_Sw_pressDown = false;
			}
#endif

#if STATELESS_PROG_SW2_SERVICE_ENABLE
		
			if((hStateless_Prog_Sw2_pressCnts > 0) && hStateless_Prog_Sw2_timeout && clock_time_exceed(hStateless_Prog_Sw2_timeout, 1000*1000))
			{
				static u8 hStateless_Prog_Sw2_pressCnts_tmp2 = 0;
				hStateless_Prog_Sw2_pressCnts_tmp2 = hStateless_Prog_Sw2_pressCnts;
				
				hStateless_Prog_Sw2_timeout = 0;

				if(hStateless_Prog_Sw2_pressCnts == 1)
				{
					if(hStateless_Prog_Sw2_pressDown)
					{
						gpio_write(BUTTON_SW2_SW3_BASE, 0);
						gpio_write(BUTTON_SW4_SW5_BASE, 1);
						sleep_us(1);
						//u32 b1 = gpio_read(BUTTON_SW2_SW4_PIN); 	//SW2
						u32 b2 = gpio_read(BUTTON_SW3_SW5_PIN); 	//SW3
						if(b2 == 0) 	//SW3 keep the status of press down.
						{
							hStateless_Prog_Sw2_ProgSwEvent = 2;
						}
						else
						{
							hStateless_Prog_Sw2_pressDown = false;
						}
					}
					if(!hStateless_Prog_Sw2_pressDown)
					{
						hStateless_Prog_Sw2_ProgSwEvent = 0;
					}
				}
				else if(hStateless_Prog_Sw2_pressCnts == 2)
				{
					hStateless_Prog_Sw2_ProgSwEvent = 1;
				}

				if(hStateless_Prog_Sw2_pressCnts <= 2)
				{
					store_char_value_to_flash();
					
					if(EventNotifyCNT)
						if(bltc.conn_terminate_pending == 0)
						{
							if(indicate_handle_no_send_once_after_checkit(STATELESSPROGSW2_HANDLE_NUM_PROGSWEVENT) == 1)
								sleep_us(250);
						}
						
					blt_adv_set_global_state ();
				}
				hStateless_Prog_Sw2_pressCnts = 0;
				hStateless_Prog_Sw2_pressDown = false;
			}
#endif

		factory_reset_cnt_check();
		
		// save current characteristic value
		if(store_char_change_value_timeout && clock_time_exceed(store_char_change_value_timeout, 3000*1000)){
			store_char_change_value_timeout = 0;
			dev_characteristic_store_to_flash();
		}
		
		#if HK_SRP_PUBKEY_UPDATE_ENABLE
		if(remove_invalid_srpkey_timeout){

			if((clock_time_exceed(remove_invalid_srpkey_timeout, 30000*1000) && (!pairPaired())) || clock_time_exceed(remove_invalid_srpkey_timeout, 60000*1000)){
				
				remove_invalid_srpkey_timeout = 0;

				extern int srpNum_pairSetup;
				extern bool srpkey2_exist;
				extern u8 srp_publickey_cnts;
				
				if(srpkey2_exist)
				{
					u8 srpNum_pairSetup_tmp;
					u8 srpNum;
					if(srpNum_pairSetup <= 0)
					{
						srpNum_pairSetup_tmp = 0;	//consume it start from 1st srp & remove the 2nd sector.
					}
					else
					{
						for(srpNum = 0; srpNum < srp_publickey_cnts; srpNum++)
						{
							if(srpNum_pairSetup & (1 << srpNum)) break;
						}
						srpNum_pairSetup_tmp = srpNum;
					}

					//if(srpInitKey_valid_num_get() <= 0)
					{
						if((srpNum_pairSetup_tmp == 1)|| (srpNum_pairSetup_tmp == 3))
							srpNum_pairSetup_tmp -= 1;
					}
					
					u32 flash_adr_srp_key = 0;
					u8 srpkey_valid_flag = 0xFF;
					if(srpNum_pairSetup_tmp == 2)
					{
						flash_adr_srp_key = (flash_adr_layout.flash_adr_srp_key);
						flash_read_page(flash_adr_srp_key + 2, 1, (u8 *)&srpkey_valid_flag);
					}
					else if(srpNum_pairSetup_tmp == 0)
					{
						flash_adr_srp_key = (flash_adr_layout.flash_adr_srp_key2);
						flash_read_page(flash_adr_srp_key + 2, 1, (u8 *)&srpkey_valid_flag);
					}

					if((srpNum_pairSetup_tmp == 0) || (srpNum_pairSetup_tmp == 2))
					{
						if(srpkey_valid_flag == SRPKEY_USED_IN_PAIR)	//0xFE: invalid flag
						{
							flash_erase_sector(flash_adr_srp_key);
							REG_ADDR8(0x6F) = 0x20; 			   // rst all(act as power on reset)
							while (1);
							//srpInitKey_other_without_led_ind(flash_adr_srp_key, flash_adr_srp_key_crc_data);
						}
					}
				}
			}
		}
		#endif
	}

}

#endif	/*HK_TEST_CASE_SIMULATE_ENABLE*/
