/********************************************************************************************************
 * @file     user_app.c
 *
 * @brief    for TLSR chips
 *
 * @author	 public@telink-semi.com;
 * @date     Sep. 18, 2018
 *
 * @par      Copyright (c) Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *			 The information contained herein is confidential and proprietary property of Telink
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in.
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 *
 *******************************************************************************************************/
#ifndef _USER_APP_C_
#define _USER_APP_C_

#include "../common.h"
#include "user_app.h"

#if USER_REDEFINE_FUNC_ENABLE

/*Only used to demonstrate the callback interface to the customer.*/
void user_task_connect (u8 e, u8 *p, int n)
{
	//task_connect callback for user
	/*
	printf("<%s:%d>\n", __FUNCTION__, __LINE__);
	printf("e = %X, n = %d\r\n", e, n);
	printf("p[%d] = {", n);
	for(int i = 0; i < n; i++)
		printf(" %X,", p[i]);
	printf("}\r\n");
	*/
	return;
}

void user_ble_remote_terminate(u8 e,u8 *p, int n)
{
	//ble_remote_terminate callback for user
	//printf("<%s:%d>\n", __FUNCTION__, __LINE__);
	return;
}


int user_lightOnReadCallback(void *pp)
{
	//lightOnRead callback for user
	//printf("<%s:%d>\n", __FUNCTION__, __LINE__);
    return 1;
}

/*
 * user can redefine the function api that prefix with "_USER_CAN_REDEFINE_".
 * eg:_USER_CAN_REDEFINE_ void light_enable (int en) in app.c
 */
void light_enable (int en)
{
	//printf("<%s:%d>\n", __FUNCTION__, __LINE__);
	
	#if LIGHTBULB_SERVICE_ENABLE
    light_onoff = en;
	#endif
    pwm_light_enable (en);

}

#endif

#endif /* _USER_APP_C_ */

/* %% End Of File %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
